/*
 *
 *  ߥˡ˥塼꡼
 *
 *  Copyright 1991-1999 Matsushita Soft-Research, INC. A.Takuma
 *
 *  System      : Mini News Reader
 *  Sub system  : Article select define
 *  File        : article.h
 *  Version     : 1.22
 *  First Edit  : 1991-07/25
 *  Last  Edit  : 1999-04/12
 *  Author      : MSRS3  
 *
 */

#ifndef	CONFIRM_NUMBER
#define	CONFIRM_NUMBER	256
#endif	/* !CONFIRM_NUMBER */
#define	THREAD_SUBJECT1	" | "
#define	THREAD_SUBJECT2	" ||"
#define	THREAD_SUBJECT3	"| "
#define	THREAD_CHAR	'|'
#define	MY_ADRS_CHAR	'='

#if	defined(SMALL) || (defined(MSDOS) && !defined(__GO32__) && !defined(__WIN32__) && !defined(X68K))
/*
 * 16bit  MS-DOS Ǥ malloc  64KB ɤ뤿礭ƤϤޤ
 */
#define	NEWS_MAX_ARTICLE	256
#else	/* !(SMALL || (MSDOS && !__GO32__ && !__WIN32__ & !X68K)) */
#define	NEWS_MAX_ARTICLE	1024
#endif	/* !(SMALL || (MSDOS && !__GO32__ && !__WIN32__ & !X68K)) */

/*
 * ưޡ
 */

typedef	struct kill_struct	KILL_LIST;
struct kill_struct {
  int			mode;	/* ޡ⡼(0:Subject,1:From)	*/
  char			field[MAX_FIELD_LEN];
  KILL_LIST		*next_ptr;
};

extern short	max_thread_number;	/* 缫ưȿ		*/
extern short	news_article_mask;	/* ˥塼ޥ⡼	*/
extern short	mail_article_mask;	/* ᡼뵭ޥ⡼	*/
extern short	news_thread_mode;	/* ˥塼åɥ⡼	*/
extern short	mail_thread_mode;	/* ᡼륹åɥ⡼		*/
extern short	article_format;		/* եޥå		*/
extern short	cross_mark_mode;	/* ݥȻޡ⡼	*/
extern short	my_adrs_mode;		/* ɥ쥹Ѵ⡼		*/
extern short	unixfrom_mode;		/* UNIX-From ⡼		*/
extern short	auto_inc_mode;		/* ᡼뼫ư⡼		*/
extern char	auto_inc_folder[];	/* ᡼뼫ưե	*/
extern char	lpr_command[];		/* ޥ			*/
extern KANJICODE pipe_code;		/* ѥ״		*/
extern KANJICODE lpr_code;		/* 		*/
extern short	sort_rule;		/* ˡ			*/
#ifdef	REF_SORT
extern MESSAGE_LIST	*message_list;	/* åꥹ		*/
#endif	/* REF_SORT */

#ifdef	__STDC__
int		news_select_article(void);
					/* 			*/
int		search_subjects(int, int, int*, int (*)());
					/* ֥ȸ(ʣ)	*/
int		search_subject(int, char*, int (*)());
					/* ֥ȸ(ñ)	*/
int		search_articles(int, int, int*, int (*)());
					/* Ƹ(ʣ)		*/
int		search_article(int, char*, int (*)());
					/* Ƹ(ñ)		*/
void		kill_subjects(int, int, int, int (*)(), void (*)());
					/* Ʊ쥵֥ȥޡ	*/
void		add_kill_list(int, char*);
					/* ưޡɲ		*/
void		multi_mark(int, int);	/* ޥޡ/	*/
void		multi_clear(int);	/* ޥޡõ		*/
void		multi_add_mark(int, int, int, int, void (*)());
					/* ʣޡ		*/
int		multi_extract(int, char*, int (*)());
					/* ʣ			*/
void		print_articles(int, int, int, int (*)(), char*);
					/* ɽ			*/
int		sort_articles(int, int*, short, short, int (*)(), void (*)());
					/* 			*/
int		pack_articles(int, int*, int (*)(), void (*)());
					/* ѥå			*/
void		toggle_mark(int, int, int);
					/* ޡȿž/ɽ		*/
int		multi_save(int, int (*)());
					/* ʣ		*/
int		multi_pipe(int, int (*)());
					/* ʣѥ׼¹		*/
int		multi_print(int, int (*)());
					/* ʣ			*/
int		save_article(int, int (*)(), char*);
					/* (̴ؿ)		*/
int		change_sort_rule(int, int*, int*, short*, short*, int (*)(),
				 int);	/* ѥå/ˡ	*/
void		create_temp_name(char*, char*);
					/* ȥե̾		*/
#else	/* !__STDC__ */
int		news_select_article();	/* 			*/
int		search_subjects();	/* ֥ȸ(ʣ)	*/
int		search_subject();	/* ֥ȸ(ñ)	*/
int		search_articles();	/* Ƹ(ʣ)		*/
int		search_article();	/* Ƹ(ñ)		*/
void		kill_subjects();	/* Ʊ쥵֥ȥޡ	*/
void		add_kill_list();	/* ưޡɲ		*/
void		multi_mark();		/* ޥޡ/	*/
void		multi_clear();		/* ޥޡõ		*/
void		multi_add_mark();	/* ʣޡ		*/
int		multi_extract();	/* ʣ			*/
void		print_articles();	/* ɽ			*/
int		sort_articles();	/* 			*/
int		pack_articles();	/* ѥå			*/
void		toggle_mark();		/* ޡȿž/ɽ		*/
int		multi_save();		/* ʣ		*/
int		multi_pipe();		/* ʣѥ׼¹		*/
int		multi_print();		/* ʣ			*/
int		save_article();		/* (̴ؿ)		*/
int		change_sort_rule();	/* ѥå/ˡ	*/
void		create_temp_name();	/* ȥե̾		*/
#endif	/* !__STDC__ */
