/*
 *
 *  ߥˡ˥塼꡼
 *
 *  Copyright 1991-1999 Matsushita Soft-Research, INC. A.Takuma
 *
 *  System      : Mini News Reader
 *  Sub system  : MH support define
 *  File        : mh.h
 *  Version     : 1.22
 *  First Edit  : 1992-07/16
 *  Last  Edit  : 1999-12/19
 *  Author      : MSRS3  
 *
 */

#define	MH_MAX_FOLDER_NAME	128
/*
#define	MH_MAX_ARTICLE		8192
*/
#define	MH_ALLOC_COUNT		8
#define	MH_DEFAULT_PATH		"Mail"
#define	MH_DEFAULT_FOLDER	"inbox"
#define	MH_DEFAULT_F_PROTECT	(S_IREAD | S_IWRITE | S_IEXEC)
#define	MH_DEFAULT_M_PROTECT	(S_IREAD | S_IWRITE)
#define	MH_DRAFT_FOLDER		"drafts"

#if	defined(MSDOS) && !defined(USE_LONG_FNAME)
#ifdef	X68K
#define	MH_INIT_FILE		"_mh_profile"
#define	MH_SEQ_FILE		"_mh_sequences"
#else	/* !X68K */
#define	MH_INIT_FILE		"_mh_prof"
#define	MH_SEQ_FILE		"_mh_sequ"
#endif	/* !X68K */
#else	/* !MSDOS || USE_LONG_FNAME */
#define	MH_INIT_FILE		".mh_profile"
#define	MH_SEQ_FILE		".mh_sequences"
#endif	/* !MSDOS || USE_LONG_FNAME */

#define	MH_CONTEXT_FILE		"context"
#define	MH_CONTEXT_FIELD	"Current-Folder:"

#define	MH_CURRENT_FIELD	"cur:"

#define	MH_PATH_FIELD		"Path:"
#define	MH_UNSEEN_FIELD		"Unseen-Sequence:"
#define	MH_DRAFT_FIELD		"Draft-folder:"
#define	MH_F_PROTECT_FIELD	"Folder-Protect:"
#define	MH_M_PROTECT_FIELD	"Msg-Protect:"
#define	MH_ALIAS_FIELD		"Aliasfile:"
#define	MH_RMM_FIELD		"rmm:"
#define	MH_RMMPROC_FIELD	"rmmproc:"

#define	MH_JN_DOMAIN		"mhfoldername"

/*
 * եѥ졼
 */

#define	FOLDER_SEPARATOR	'/'

#define	MH_READ_FIELD		"Seen:"
#define	MH_REPLY_FIELD		"Replied:"
#define	MH_FORWARD_FIELD	"Forwarded:"

/*
 * MH ޥ
 */

#define	MH_FOLDER_COMMAND	"folder"
#define	MH_REFILE_COMMAND	"refile"
#define	MH_SORTM_COMMAND	"sortm"
#define	MH_RMM_COMMAND		"rmm"
#define	MH_RMF_COMMAND		"rmf"
#define	MH_INC_COMMAND		"inc"
#define	MH_PICK_COMMAND		"pick"
#define	MH_ALI_COMMAND		"ali"
#define	MH_MARK_COMMAND		"mark"
#define	MH_MSGCHK_COMMAND	"msgchk"
#define	MH_BURST_COMMAND	"burst"

/*
 * եꥹ
 */

struct mh_folder {
  char		folder_name[MH_MAX_FOLDER_NAME];/* ե̾		*/
  long		current_article;		/* ȵֹ	*/
  long		article_number;			/* 		*/
  long		unread_article;			/* ̤ɵ		*/
  long		max_article;			/* 絭ֹ		*/
  long		min_article;			/* Ǿֹ		*/
};

/*
 * եꥹ
 */

struct mh_field {
  char		*field_name;		/* ե̾			*/
  char		*field_buff;		/* եɥХåե		*/
  char		*field_default;		/* եɥǥե	*/
};

/*
 * ȹ¤
 */

struct sort_struct {
  int			order;
  unsigned short	year;
  unsigned short	month;
  unsigned short	date;
  unsigned short	hour;
  unsigned short	minute;
  unsigned short	second;
};

extern short	mh_mode;		/* MH ⡼ɥե饰		*/
extern short	mh_select_mode;		/* MH ư⡼		*/
extern short	mh_count_mode;		/* MH ̤ɥȥ⡼	*/
extern char	mh_command_path[];	/* MH ޥɥѥ		*/

#ifdef	__STDC__
int		mh_init(void);		/* MH ⡼ɽ		*/
int		mh_menu(int);		/* MH ˥塼			*/
int		save_mh_folder(int, int (*)());
					/* MH եص	*/
int		mh_expand_alias(char*, char*, char*, int);
					/* MH ꥢŸ		*/
int		mh_check_msg(void);	/* MH ᡼å	*/
int		mh_create_folder(char*);/* MH ե		*/
#else	/* !__STDC__ */
int		mh_init();		/* MH ⡼ɽ		*/
int		mh_menu();		/* MH ˥塼			*/
int		save_mh_folder();	/* MH եص	*/
int		mh_expand_alias();	/* MH ꥢŸ		*/
int		mh_check_msg();		/* MH ᡼å	*/
int		mh_create_folder();	/* MH ե		*/
#endif	/* !__STDC__ */
