/*
 *
 *  ߥˡ˥塼꡼
 *
 *  Copyright 1996-1999 Matsushita Soft-Research, INC. A.Takuma
 *
 *  System      : Mini News Reader
 *  Sub system  : MIME multipart select define
 *  File        : mimepart.h
 *  Version     : 1.22
 *  First Edit  : 1996-12/08
 *  Last  Edit  : 1999-04/12
 *  Author      : MSRS3  
 *
 */

#ifndef	__MIMEPART_H__
#define	__MIMEPART_H__

#define	X_BIN_FILE_FIELD	"X-application/octet-stream:"
#define	MIME_ALLOC_COUNT	8
#define	MIME_SUBJECT_LEN	46

/*
 * MIME ƥĹ¤
 */

typedef struct content_list	CONTENT_LIST;
struct content_list {
  CONTENT_LIST	*next_ptr;
  MIME_MTYPE	c_mtype;
  MIME_STYPE	c_stype;
  MIME_TTYPE	c_ttype;
  char		c_name[PATH_BUFF];
  long		c_size;
};

extern int	mime_news_group;	/* MIME ˥塼롼	*/
extern char	mpeg_command[];		/* MPEG  ޥ		*/
extern char	jpeg_command[];		/* JPEG  ɽޥ		*/
extern char	gif_command[];		/* GIF   ɽޥ		*/
extern char	audio_command[];	/* AUDIO ޥ		*/
extern char	ps_command[];		/* PostScript ɽޥ	*/

#ifdef	__STDC__
extern int	mime_manage(FILE*, MIME_MTYPE, MIME_STYPE, MIME_TTYPE, char*);
					/* MIME 			*/
extern int	mime_part_menu(char*, char*, int);
					/* MIME ѡȥ˥塼		*/
extern void	mime_init_content(void);/* MIME ƥĽ	*/
extern int	mime_add_content(MIME_MTYPE, MIME_STYPE, MIME_TTYPE, char*);
					/* MIME ƥϿ		*/
extern int	mime_get_content_num(void);
					/* MIME ƥĿ	*/
#else	/* !__STDC__ */
extern int	mime_manage();		/* MIME 			*/
extern int	mime_part_menu();	/* MIME ѡȥ˥塼		*/
extern void	mime_init_content();	/* MIME ƥĽ	*/
extern int	mime_add_content();	/* MIME ƥϿ		*/
extern int	mime_get_content_num();	/* MIME ƥĿ	*/
#endif	/* !__STDC__ */
#endif	/* !__MIMEPART_H__ */
