/*
 *
 *  ߥˡ˥塼꡼
 *
 *  Copyright 1991-1999 Matsushita Soft-Research, INC. A.Takuma
 *
 *  System      : Mini News Reader
 *  Sub system  : Main define
 *  File        : mnews.h
 *  Version     : 1.22
 *  First Edit  : 1991-07/25
 *  Last  Edit  : 1999-12/19
 *  Author      : MSRS3  
 *
 */

#ifndef		DONT_HAVE_FTIME
#include	<sys/timeb.h>
#endif		/* DONT_HAVE_FTIME */

#define	READER_NAME	"mnews"
#define	MNEWS_VERSION	"1.22"
#define	MNEWS_DATE	"1999-12/19(Sun)"
#define	ERROR_FILE	"mnewserr"

#if	defined(MSDOS) && !defined(USE_LONG_FNAME)
#ifdef	X68K
#define	SIGNATURE_FILE	"_signature"
#else	/* !X68K */
#define	SIGNATURE_FILE	"_sign"
#endif	/* !X68K */
#define	MESSAGE_FILE	"_message"
#define	DEAD_FILE	"deadmail"
#else	/* !MSDOS || USE_LONG_FNAME */
#define	SIGNATURE_FILE	".signature"
#define	MESSAGE_FILE	".message"
#define	DEAD_FILE	"dead.letter"
#endif	/* !MSDOS || USE_LONG_FNAME */

#define	FROM_JN_DOMAIN	"familyname"

#define	MAX_MULTI_NUMBER	30	/* ޥ		*/
#ifdef	LARGE
#define	ALIAS_BUFF		(BUFF_SIZE * 4)
#else	/* !LARGE */
#define	ALIAS_BUFF		BUFF_SIZE
#endif	/* !LARGE */

/*
 * ¾
 */

#ifndef	LF
#define	LF	0x0a
#endif	/* !LF */
#define	REPLY_SUBJECT	"Re:"	/* ץ饤֥		*/
#define	REPLY_MESSAGE	"Your message of "
#define	TEXT_SEPARATOR	"--text follows this line--"
#define	MULTI_END_MARK	"\001\n"/* ޥΥѥ졼	*/
#define	ERROR_SLEEP	3	/* 顼ȯԤ	*/
#define	HEAD_LINES	3
#define	BOTTOM_LINES	1
#define	MODE_LINES	(HEAD_LINES + BOTTOM_LINES)
#define	MAX_MAIL_GROUP	6
#define	MAX_WRITE_FILE	5
#define	JST_OFFSET	(-9)

/*
 * ޡꥹȹ¤
 */

typedef	struct mark_struct	MARK_LIST;
struct mark_struct {
  MARK_LIST	*prev_ptr;				/* ޡ	*/
  MARK_LIST	*next_ptr;				/* ޡ	*/
  long		start_number;				/* ֹ	*/
  long		end_number;				/* λֹ	*/
};

/*
 * 롼״¤
 */

typedef	struct group_struct	GROUP_LIST;
struct group_struct {
  long		unread_article;				/* ̤ɵ	*/
  MARK_LIST	*mark_ptr;				/* ޡ	*/
  short		match_flag;				/* Ŭե饰	*/
  short		unsubscribe;				/* ɥ⡼	*/
  short		mark_order;				/* ޡ	*/
};

/*
 * ̵롼״¤
 */

typedef	struct bogus_struct	BOGUS_LIST;
struct bogus_struct {
  char		group_name[MAX_GROUP_NAME];		/* 롼̾	*/
  BOGUS_LIST	*next_ptr;				/* 	*/
  MARK_LIST	*mark_ptr;				/* ޡ	*/
  short		mark_order;				/* ޡ	*/
  short		unsubscribe;				/* ɥ⡼	*/
};

/*
 * Message-ID ¤
 */

#ifdef	REF_SORT
typedef	struct message_struct	MESSAGE_LIST;
struct message_struct {
  char		msg_id[MAX_FIELD_LEN];		/* å ID	*/
  char		ref_id[MAX_FIELD_LEN];		/* ե ID	*/
};
#endif	/* REF_SORT */

/*
 * ¤
 */

typedef	struct article_struct	ARTICLE_LIST;
struct article_struct {
  long		real_number;			/* µֹ		*/
  char		from[MAX_FROM_LEN];		/* пͥɥ쥹	*/
  char		subject[MAX_SUBJECT_LEN];	/* ֥		*/
  short		mark;				/* ޡ		*/
#ifdef	REF_SORT
  short		year;				/* ǯ			*/
#endif	/* REF_SORT */
  short		month;				/* 			*/
  short		date;				/* 			*/
  short		lines;				/* Կ			*/
};

typedef enum {
  NORMAL_YN_MODE,
  CARE_YN_MODE,
  FILE_YN_MODE,
  JUMP_YN_MODE,
  MIME_YN_MODE,
  SEND_YN_MODE,
  MARK_YN_MODE,
  MMEDIA_YN_MODE
} yn_mode;

/*
 * ޡ
 */

#define	READ_MARK	0x0001
#define	FORWARD_MARK	0x0002
#define	ANSWER_MARK	0x0004
#define	DELETE_MARK	0x0008
#define	MULTI_MARK	0x0010
#define	IGNORE_MARK	0x0020
#define	UNFETCH_MARK	0x0040
#define	CANCEL_MARK	0x0080
#define	SORT_MARK	0x0100
#define	THREAD_MARK	0x0200

/*
 * ϻޥ
 */

#define	GLOBAL_MODE_MASK	0x01
#define	GROUP_MODE_MASK		0x02
#define	SUBJECT_MODE_MASK	0x04
#define	LINE_MODE_MASK		0x08
#define	YN_MODE_MASK		0x10
#define	NEWS_MODE_MASK		0x20
#define	MOUSE_MODE_MASK		0x40

#define	INPUT_SPCCUT_MASK	0x01
#define	INPUT_EXPAND_MASK	0x02
#define	INPUT_COMP_MASK		0x04
#define	INPUT_FOLDER_MASK	0x08
#define	INPUT_SHADOW_MASK	0x10

/*
 * 顼ǥå
 */

enum color_code {
  TITLE_COLOR,
  HEADER_COLOR,
  GUIDE_COLOR,
  ERROR_COLOR,
  CATEGORY_COLOR,
  MARK_COLOR,
  NUMBER_COLOR,
  FROM_COLOR,
  DATE_COLOR,
  LINE_COLOR,
  SUBJECT_COLOR,
  THREAD_COLOR,
  LOST_COLOR,
  FROM2_COLOR,
  TO_COLOR,
  CC_COLOR,
  DATE2_COLOR,
  GROUP_COLOR,
  REFER_COLOR,
  JNAMES_COLOR
};

extern GROUP_LIST	*group_list;
extern BOGUS_LIST	*bogus_list;
extern ARTICLE_LIST	*article_list;
#ifndef	MSDOS
extern struct passwd	*passwd;
#endif	/* !MSDOS */

extern char	*month_string[];	/* ̾				*/
extern char	*day_string[];		/* ̾			*/
extern char	*day_jstring[];		/* ̾(ܸ)		*/
extern char	jnames_file[];		/* JNAMES ǡե	*/
extern char	domain_name[];		/* ɥᥤ̾			*/
extern char	user_name[];		/* 桼̾			*/
extern char	user_gecos[];		/* 桼			*/
extern char	home_dir[];		/* ۡǥ쥯ȥ		*/
extern char	dot_dir[];		/* ɥåȥǥ쥯ȥ		*/
extern char	edit_command[];		/* ǥޥ		*/
extern char	*new_mail_string[];	/* ᡼å		*/
extern char	*net_opt;		/* ͥåȥ³ץ	*/
extern char	*cons_opt;		/* åȹץ	*/
extern char	*conf_opt;		/* åꥪץ	*/
extern char	*arch_opt;		/* ƥ㥪ץ	*/
extern char	*install_host;		/* 󥹥ȡۥ̾		*/
extern char	*install_user;		/* 󥹥ȡ桼̾		*/
extern char	*install_date;		/* 󥹥ȡ		*/
extern char	mark_file[];		/* ޡե		*/
extern char	pager[];		/* ڡ㡼ޥ		*/
extern char	tmp_dir[];		/* ȥǥ쥯ȥ		*/
extern char	save_dir[];		/* ֥ǥ쥯ȥ	*/
extern char	second_adrs[];		/* ɥɥ쥹		*/

extern int	multi_list[];		/* ޥե/ץ饤ꥹ*/
extern int	multi_number;		/* ޥե/ץ饤	*/
extern short	nntp_mode;		/* NNTP ѥ⡼		*/
extern short	smtp_mode;		/* SMTP ѥ⡼		*/
extern short	pop3_mode;		/* POP3 ѥ⡼		*/
extern short	rpop_mode;		/* RPOP ѥ⡼		*/
extern short	pop3_del_mode;		/* POP3 ⡼		*/
extern short	pager_mode;		/* ڡ㡼⡼		*/
extern short	japanese;		/* ܸ⡼ɥե饰		*/
extern short	jnames;			/* JNAMES ѥե饰		*/
extern short	quiet_mode;		/* ٹɽ⡼		*/
extern short	skip_mode;		/* إååץ⡼		*/
extern short	mail_mode;		/* ᡼뻲ѥ⡼		*/
extern short	error_mode;		/* 顼⡼		*/
extern short	mh_mark_mode;		/* MH ޡ⡼		*/
extern short	color_mode;		/* 顼⡼			*/
extern short	wide_mode;		/* 磻ɥ⡼			*/
extern short	bell_mode;		/* ᡼Υ٥벻⡼	*/
extern short	x_nsubj_mode;		/* X-Nsubject: ⡼		*/
extern short	x_nsubj_org;		/* X-Nsubject: ꥸʥ⡼	*/
extern short	jst_mode;		/* ܻѴ⡼		*/
extern short	mouse_mode;		/* ޥ⡼			*/
extern short	msgchk_rule;		/* ᡼åˡ		*/
extern short	mime_format;		/* MIME եޥåȽ	*/
extern short	mime_mmedia_mode;	/* MIME ޥǥ⡼	*/
extern KANJICODE default_code;		/* Ƚǽδ	*/
extern KANJICODE edit_code;		/* ǥ		*/
extern KANJICODE save_code;		/* ִ		*/
extern KANJICODE input_code;		/* 1 ϴ		*/
extern char	config_file[];		/* եե		*/
extern int	mime_form_char;		/* MIME եޥåȥ⡼ʸ	*/
extern int	(*mime_encode_func)();	/* MIME ǥɴؿ		*/
extern int	(*mime_decode_func)();	/* MIME ǥɴؿ		*/

extern short	head_lines;		/* إå饤Կ		*/
extern short	mode_lines;		/* ⡼ɥ饤Կ		*/
extern short	color_code[];		/* 顼			*/
#ifdef	MOUSE
extern int	mouse_button, mouse_column, mouse_row;	/* ޥ	*/
#endif	/* MOUSE */
extern char	show_filter[];		/* ȥե륿		*/

#ifdef	__STDC__
void		help(char**, char**, int);	/* إɽ(ˡ)	*/
void		print_title(void);		/* ȥɽ		*/
#ifdef	DONT_HAVE_DOPRNT
void		print_mode_line();		/* ⡼ɥ饤ɽ	*/
void		print_full_line();		/* 1 ԥեɽ		*/
int		yes_or_no();
					/* Y/N ϳǧ			*/
void		edit_fprintf();
					/* ǥѴʸ	*/
#else	/* !DONT_HAVE_DOPRNT */
void		print_mode_line(char*, ...);
						/* ⡼ɥ饤ɽ	*/
void		print_full_line(char*, ...);
						/* 1 ԥեɽ		*/
int		yes_or_no(yn_mode, char*, char*, ...);
						/* Y/N ϳǧ		*/
void		edit_fprintf(FILE*, char*, ...);
						/* ǥʸ	*/
#endif	/* !DONT_HAVE_DOPRNT */
void		input_line(int, char*, char*, char*);
						/* 1 		*/
int		check_abort(void);		/* ǥå		*/
char		*input_search_string(int);	/* ʸ	*/
void		field_fprintf(FILE*, char*, char*, char*, char*, char*,
			      char*);	/* եɥեޥåȽ	*/
void		suspend(void);			/* ڥ		*/
char		*strindex(char*, char*);	/* ʸ󸡺		*/
int		fgets2(char*, int, FILE*);	/* ե뤫 1 */
int		convert_code(char*, char*, KANJICODE, int);
						/* Ѵ	*/
void		convert_article_date(char*, short*, short*, short*,
				     short*, short*, short*, short*, char*);
						/* DateեޥåѴ	*/
char		*next_param(char*);		/* ѥ᡼	*/
int		gmt_to_jst(short*, short*, short*, short*, short*, short*,
			   short*);		/* GMTJST Ѵ	*/
int		get_jadrs(char*, char*);	/* ܸ쥢ɥ쥹	*/
void		get_jname(char*, char*, int);	/* ܸ̾		*/
int		check_my_adrs(char*);		/* ɥ쥹å	*/
int		get_key(int);			/* 1 ʸ	*/
int		get_top_position(int, int, int, short, char*);
						/* ַ׻	*/
int		check_new_mail(void);		/* ᡼å	*/
int		exec_pager(char*, char*, int, char*);
						/* ڡ㵯ư		*/
int		exec_editor(char *, int);	/* ǥư		*/
NNTP_ERR_CODE	open_nntp_server(int);		/* NNTP ³	*/
void		create_date_field(char*, struct tm*);
						/* Date: ե	*/
void		pipe_error(void);		/* ѥץ顼ϥɥ	*/
void		force_exit(void);		/* λ		*/
FILE		*fopen2(char*, char*);		/* ե		*/
int		fclose2(char*);			/* ե		*/
int		funlink2(char*);		/* ե		*/
int		make_dir(char*, int);		/* ǥ쥯ȥ	*/
void		usage(int);			/* إɽ		*/
#else	/* !__STDC__ */
void		help();				/* إɽ(ˡ)	*/
void		print_title();			/* ȥɽ		*/
void		print_mode_line();		/* ⡼ɥ饤ɽ	*/
void		print_full_line();		/* 1 ԥեɽ		*/
int		yes_or_no();			/* Y/N ϳǧ		*/
void		edit_fprintf();			/* ǥʸ	*/
void		input_line();			/* 1 		*/
int		check_abort();			/* ǥå		*/
char		*input_search_string();		/* ʸ	*/
void		field_fprintf();	/* եɥեޥåȽ	*/
void		suspend();			/* ڥ		*/
char		*strindex();			/* ʸ󸡺		*/
int		fgets2();			/* ե뤫 1 */
int		convert_code();			/* Ѵ	*/
void		convert_article_date();		/* DateեޥåѴ	*/
char		*next_param();			/* ѥ᡼	*/
int		gmt_to_jst();			/* GMTJST Ѵ	*/
int		get_jadrs();			/* ܸ쥢ɥ쥹	*/
void		get_jname();			/* ܸ̾		*/
int		check_my_adrs();		/* ɥ쥹å	*/
int		get_key();			/* 1 ʸ	*/
int		get_top_position();		/* ַ׻	*/
int		check_new_mail();		/* ᡼å	*/
int		exec_pager();			/* ڡ㵯ư		*/
int		exec_editor();			/* ǥư		*/
NNTP_ERR_CODE	open_nntp_server();		/* NNTP ³	*/
void		create_date_field();		/* Date: ե	*/
void		pipe_error();			/* ѥץ顼ϥɥ	*/
void		force_exit();			/* λ		*/
FILE		*fopen2();			/* ե		*/
int		fclose2();			/* ե		*/
int		funlink2();			/* ե		*/
int		make_dir();			/* ǥ쥯ȥ	*/
void		usage();			/* إɽ		*/
#endif	/* !__STDC__ */

#ifdef	__STDC__
void		set_mime_decode_func(void);
					/* MIME ǥɴؿϿ	*/
int		net_config(void);	/* ͥåȥե졼	*/
int		env_config(char*);	/* Ķե졼	*/
void		setup_mono(void);	/* Υ⡼ɥ顼	*/
void		create_msg_id(char*);	/* Message-ID 		*/
#else	/* !__STDC__ */
void		set_mime_decode_func();	/* MIME ǥɴؿϿ	*/
int		net_config();		/* ͥåȥե졼	*/
int		env_config();		/* Ķե졼	*/
void		setup_mono();		/* Υ⡼ɥ顼	*/
void		create_msg_id();	/* Message-ID 		*/
#endif	/* !__STDC__ */

#ifdef	DONT_USE_ABORT
#define	term_enable_abort()
#define	term_disable_abort()
#define	check_abort()		0
#else	/* !DONT_USE_ABORT */
#ifdef	USE_SELECT_ABORT
#define	term_enable_abort()
#define	term_disable_abort()
#else	/* !USE_SELECT_ABORT */
#define	check_abort()	(term_abort_flag)
#endif	/* !USE_SELECT_ABORT */
#endif	/* !DONT_USE_ABORT */
