/*
 *
 *  ߥˡ˥塼꡼
 *
 *  Copyright 1991-1999 Matsushita Soft-Research, INC. A.Takuma
 *
 *  System      : Mini News Reader
 *  Sub system  : RMAIL support routine
 *  File        : rmail.c
 *  Version     : 1.22
 *  First Edit  : 1992-07/23
 *  Last  Edit  : 1999-12/15
 *  Author      : MSRS3  
 *
 */

#ifdef	RMAIL
#include	"compat.h"
#include	"nntplib.h"
#include	"smtplib.h"
#include	"pop3lib.h"
#include	"field.h"
#include	"kanjilib.h"
#include	"termlib.h"
#include	"mnews.h"
#include	"group.h"
#include	"rmail.h"
#include	"article.h"
#include	"pager.h"
#include	"mailsend.h"

#ifdef	__STDC__
static int	rmail_select_folder(void);
				 	/* ե			*/
static void	rmail_redraw_folder(int);
					/* ե̺	*/
static int	rmail_select_article(int);
					 /* 			*/
static void	rmail_redraw_article(int, int);
					/* ̺		*/
static int	rmail_prev_folder(int);	/* եֹ		*/
static int	rmail_next_folder(int);	/* եֹ		*/
static int	rmail_prev_unread_folder(int);
					/* ̤ɥեֹ	*/
static int	rmail_next_unread_folder(int);
					/* ̤ɥեֹ	*/
static int	rmail_prev_article(int);/* ֹ		*/
static int	rmail_next_article(int);/* ֹ		*/
static int	rmail_prev_unread_article(int);
					/* ֹ		*/
static int	rmail_next_unread_article(int);
					/* ֹ		*/
#ifdef	LARGE
static int	rmail_prev_mark_article(int);
					/* ޡֹ		*/
static int	rmail_next_mark_article(int);
					/* ޡֹ		*/
#endif	/* LARGE */
static void	rmail_search_all_folder(void);
					/* ե		*/
static void	rmail_search_folder(char*);
					/* ե			*/
static void	rmail_match_folder(char*);
					/* եȹ			*/
static int	rmail_read(long, int);	/* 			*/
static int	rmail_extract(long, char*);
					/* 			*/
static void	rmail_mark(int, int);	/* ޡɲ		*/
static void	rmail_unmark(int, int);	/* ޡ		*/
static void	rmail_count(int);	/* 		*/
static int	rmail_get_list(void);	/* ꥹȼ		*/
static void	rmail_include(char*, int);
					/* 嵭		*/
static void	rmail_update(int, char*);
					/* RMAIL ե빹		*/
static int	rmail_create_folder(char*);
					/* ե			*/
static int	rmail_delete_folder(char*);
					/* ե			*/
static int	rmail_adjust_folder(char*);
					/* ե		*/
static int	rmail_search_name(int, int, int*);
					/* ե̾		*/
#else	/* !__STDC__ */
static int	rmail_select_folder(); 	/* ե			*/
static void	rmail_redraw_folder();	/* ե̺	*/
static int	rmail_select_article(); /* 			*/
static void	rmail_redraw_article();	/* ̺		*/
static int	rmail_prev_folder();	/* եֹ		*/
static int	rmail_next_folder();	/* եֹ		*/
static int	rmail_prev_unread_folder();
					/* ̤ɥեֹ	*/
static int	rmail_next_unread_folder();
					/* ̤ɥեֹ	*/
static int	rmail_prev_article();	/* ֹ		*/
static int	rmail_next_article();	/* ֹ		*/
static int	rmail_prev_unread_article();
					/* ֹ		*/
static int	rmail_next_unread_article();
					/* ֹ		*/
#ifdef	LARGE
static int	rmail_prev_mark_article();
					/* ޡֹ		*/
static int	rmail_next_mark_article();
					/* ޡֹ		*/
#endif	/* LARGE */
static void	rmail_search_all_folder();
					/* ե		*/
static void	rmail_search_folder();	/* ե			*/
static void	rmail_match_folder();	/* եȹ			*/
static int	rmail_read();		/* 			*/
static int	rmail_extract();	/* 			*/
static void	rmail_mark();		/* ޡɲ		*/
static void	rmail_unmark();		/* ޡ		*/
static void	rmail_count();		/* 		*/
static int	rmail_get_list();	/* ꥹȼ		*/
static void	rmail_include();	/* 嵭		*/
static void	rmail_update();		/* RMAIL ե빹		*/
static int	rmail_create_folder();	/* ե			*/
static int	rmail_delete_folder();	/* ե			*/
static int	rmail_adjust_folder();	/* ե		*/
static int	rmail_search_name();	/* ե̾		*/
#endif	/* !__STDC__ */

/*
 * RMAIL եꥹ
 */

static int	rmail_folder_number;	/* RMAIL ե		*/
static int	rmail_select_number;	/* 򤵤Ƥե	*/
static int	rmail_alloc_number;	/* RMAIL ե		*/
static char	rmail_file[PATH_BUFF];	/* RMAIL եե̾	*/
static int	top_position;		/* ɽϰ			*/
static int	rmail_article_number;	/* RMAIL 			*/
static int	rmail_modify;		/* RMAIL ե饰		*/
static struct rmail_folder	*rmail_folder = (struct rmail_folder*)NULL;
					/* RMAIL ե		*/
static struct rmail_folder	*rmail_s_folder = (struct rmail_folder*)NULL;
					/* RMAIL ե		*/

static char	*rmail_ignore_field[] = {
  "Via:",
  "Mail-From:",
  "Origin:",
  "Status:",
  "Received:",
  "Message-ID:",
  "Summary-Line:"
  };

/*
 * RMAIL إץå
 */

static char	*rmail_folder_jmessage[] = {
  "RMAIL ե⡼",
  "\n  []",
  "\ti ޤ SPACE  ե򤷤ޤ",
  "\n  [ư]",
  "\tk ޤ ^P     Υե˰ưޤ",
  "\tj ޤ ^N     Υե˰ưޤ",
  "\tp               ̤ɥե˰ưޤ",
  "\tn               ̤ɥե˰ưޤ",
  "\t^U ޤ ^B    ̤Υե˰ưޤ",
  "\t^D, ^F ޤ ^V",
  "\t                ̤Υե˰ưޤ",
  "\t<               ƬΥե˰ưޤ",
  "\t>               ǸΥե˰ưޤ",
  "\tTAB             Υեƥޤϥե˥פޤ",
  "\t                (եƥޤϥե̾ϤƲ)",
#ifdef	LARGE
  "\tI               ѥե˰ưޤ",
#endif	/* LARGE */
  "\to, q ޤ RETURN",
  "\t                ե⡼ɤȴޤ",
#ifdef	MAILSEND
  "\n  []",
  "\tm               ˥᡼Фޤ",
#endif	/* MAILSEND */
#ifndef	SMALL
  "\n  []",
  "\t/               ե̾ޤ",
  "\t                (ʸϤƲ)",
  "\t\\               ե̾ޤ",
  "\t                (ʸϤƲ)",
#endif	/* !SMALL */
  "\n  [ɽ]",
  "\tG               ˥塼롼/եɽؤޤ",
  "\t                (ȥåץեƥΤͭ)",
  "\001",
  "\tC               ˥եޤ",
  "\t                (ե̾ϤƲ)",
  "\tDEL ޤ BS   եޤ",
  "\t                (y/n ǳǧƤޤ)",
  (char*)NULL,
  };

static char	*rmail_article_jmessage[] = {
  "RMAIL ⡼",
  "\n  []",
  "\tSPACE, i ޤ .",
  "\t                򻲾Ȥޤ",
  "\tv ޤ V      ƤΥإåȤȤ˵򻲾Ȥޤ",
#ifdef	MIME
  "\t                ('V'  MIME ǥб)",
#endif	/* MIME */
  "\tp               ̤ɵ򻲾Ȥޤ",
  "\tn               ̤ɵ򻲾Ȥޤ",
  "\tP               ε򻲾Ȥޤ",
  "\tN               ε򻲾Ȥޤ",
  "\n  [ư]",
  "\tk ޤ ^P     ε˰ưޤ",
  "\tj ޤ ^N     ε˰ưޤ",
  "\t^U ޤ ^B    ̤ε˰ưޤ",
  "\t^D, ^F ޤ ^V",
  "\t                ̤ε˰ưޤ",
  "\t<               Ƭε˰ưޤ",
  "\t>               Ǹε˰ưޤ",
  "\tTAB             ε˥פޤ",
  "\t                (ֹϤƲ)",
#ifdef	LARGE
  "\t{               κޡ˰ưޤ",
  "\t}               κޡ˰ưޤ",
#endif	/* LARGE */
  "\to, q ޤ RETURN",
  "\t                ⡼ɤȴޤ",
  "\n  [ޡ]",
  "\tD               ޡεذưޤ",
  "\td               ޡεذưޤ",
  "\tU               ޡεذưޤ",
  "\tu               ޡεذưޤ",
  "\tY               ɥޡεذưޤ",
  "\ty               ɥޡεذưޤ",
  "\tZ               ɥޡεذưޤ",
  "\tz               ɥޡεذưޤ",
  "\tM               ޥޡ/εذưޤ",
  "\tC               ¸ޡεذưޤ",
  "\tc               ޡޤ",
  "\t                (y:ɥޡ n: d:ޡ 򤷤Ʋ)",
#ifdef	MAILSEND
  "\n  []",
  "\tm               ˥᡼Фޤ",
  "\tr               ֿޤ",
  "\tR               Ѥֿޤ",
  "\t= ޤ f      žޤ",
#ifdef	LARGE
  "\t~               ޤ",
#endif	/* LARGE */
#endif	/* MAILSEND */
  "\n  []",
  "\ts               򥻡֤ޤ",
  "\t                (ե̾ϤƲե뤬¸ߤ",
  "\t                 y:ڥ n: o:񤭤ǲ)",
  "\n  []",
  "\tI               ᡼ߤޤ",
#ifndef	SMALL
  "\tL               UCB-mail εեߤޤ",
  "\t                (ե̾ϤƲ)",
#endif	/* !SMALL */
  "\n  [/]",
  "\tDEL ޤ BS   ޡ줿ޤ",
  "\t                (y/n ǳǧƤޤ)",
  "\t^               ޡ줿̤Υե˰ưޤ",
  "\t                (ưե̾Ƥޤ)",
  "\n  [ɽ]",
  "\tl               /줿ɽ⡼ɤؤޤ",
  "\tt               åɥ⡼ɤؤޤ",
#ifdef	REF_SORT
  "\tT               ˡؤޤ",
#endif	/* REF_SORT */
  (char*)NULL,
};

static char	*rmail_folder_message[] = {
#ifndef	SMALL
  "RMAIL FOLDER SELECT MODE",
  "\n  [SELECT]",
  "\ti or SPACE   select folder.",
  "\n  [MOVE]",
  "\tk or ^P      previous folder.",
  "\tj or ^N      next folder.",
  "\tp            previous unread folder.",
  "\tn            next unread folder.",
  "\t^U or ^B     previous page folder.",
  "\t^D, ^F or ^V next page folder.",
  "\t<            top folder.",
  "\t>            last folder.",
  "\tTAB          jump to specified category/folder.",
  "\t             (Please input folder name.)",
#ifdef	LARGE
  "\tI            jump to new article folder.",
#endif	/* LARGE */
  "\to, q or RETURN",
  "\t             exit from folder select mode.",
#ifdef	MAILSEND
  "\n  [SEND]",
  "\tm            mail.",
#endif	/* MAILSEND */
  "\n  [SEARCH]",
  "\t/            forward search pattern.",
  "\t             (Please input search pattern.)",
  "\t\\            backward search pattern.",
  "\t             (Please input search pattern.)",
  "\n  [DISPLAY]",
  "\tG            toggle news(board) group/folder print mode.",
  "\t             (When top folder only)",
  "\001",
  "\tC            create new folder.",
  "\t             (Please input folder name.)",
  "\tDEL or BS    delete folder.",
  "\t             (Please make sure y/n.)",
#endif	/* !SMALL */
  (char*)NULL,
  };

static char	*rmail_article_message[] = {
#ifndef	SMALL
  "RMAIL ARTICLE SELECT MODE",
  "\n  [READ]",
  "\tSPACE, i or .",
  "\t             read article.",
  "\tv or V       read article with all header.",
#ifdef	MIME
  "\t             ('V' decode MIME header.)",
#endif	/* MIME */
  "\tp            read previous unread article.",
  "\tn            read next unread article.",
  "\tP            read previous article.",
  "\tN            read next article.",
  "\n  [MOVE]",
  "\tk or ^P      previous article.",
  "\tj or ^N      next article.",
  "\t^U or ^B     previous page article.",
  "\t^D, ^F or ^V next page article.",
  "\t<            top article.",
  "\t>            last article.",
  "\tTAB          jump to specified article.",
  "\t             (Please input article number.)",
#ifdef	LARGE
  "\t{            previous delete mark article.",
  "\t}            next delete mark article.",
#endif	/* LARGE */
  "\to, q or return",
  "\t             exit from article select mode.",
  "\n  [MARK]",
  "\tD            mark for delete and move to previous.",
  "\td            mark for delete and move to next.",
  "\tU            clear delete mark and move to previous.",
  "\tu            clear delete mark and move to next.",
  "\tY            mark as read and move to previous.",
  "\ty            mark as read and move to next.",
  "\tZ            clear read mark and move to previous.",
  "\tz            clear read mark and move to next.",
  "\tM            toggle multi mark and move to next.",
  "\tC            clear all saved mark and move to next.",
  "\tc            mark all articles.",
  "\t             (Please select y:read n:abort or d:delete mark.)",
#ifdef	MAILSEND
  "\n  [SEND]",
  "\tm            mail.",
  "\tr            reply.",
  "\tR            reply with original article.",
  "\t= or f       forward.",
#ifdef	LARGE
  "\t~            relay.",
#endif	/* LARGE */
#endif	/* MAILSEND */
  "\n  [SAVE]",
  "\ts            save article.",
  "\t             (Please input file name.If file exists, please select",
  "\t              y:append n:abort or o:overwrite.)",
  "\n  [INCLUDE]",
  "\tI            include new mail.",
  "\tL            include UCB-mail format article file.",
  "\t             (Please input file name.)",
  "\n  [DELETE/REORDER]",
  "\tDEL or BS    remove delete marked article.",
  "\t             (Please make sure y/n.)",
  "\t^            refile delete marked article.",
  "\t             (Please input folder name.)",
  "\n  [DISPLAY]",
  "\tl            toggle print read/delete article.",
  "\tt            toggle thread mode.",
#ifdef	REF_SORT
  "\tT            change sort rule.",
#endif	/* REF_SORT */
#endif	/* !SMALL */
  (char*)NULL,
};

/*
 * RMAIL ⡼ɽ
 */

#ifdef	__STDC__
int	rmail_init(void)
#else	/* !__STDC__ */
int	rmail_init()
#endif	/* !__STDC__ */
{
  return(rmail_mode);
}

/*
 * RMAIL ˥塼
 */

#ifdef	__STDC__
int	rmail_menu(int top_flag)
#else	/* !__STDC__ */
int	rmail_menu(top_flag)
     int	top_flag;
#endif	/* !__STDC__ */
{
  struct stat	stat_buff;
  int		status;

  print_mode_line(japanese ? "Ǥ" : "Searching.");
  if (top_flag) {
    if ((!stat(rmail_mbox, &stat_buff)) && (stat_buff.st_mode & S_IFDIR)) {
      rmail_search_all_folder();
      if (!jump_name[0]) {
	if (auto_inc_mode && auto_inc_folder[0] && (check_new_mail() > 0)) {
	  strcpy(jump_name, auto_inc_folder);
	}
      }
    } else {
      rmail_folder_number = 0;
      strcpy(rmail_file, rmail_mbox);
      return(rmail_select_article(auto_inc_mode));
    }
  }
  while (1) {
    rmail_match_folder(select_name);
    status = rmail_select_folder();
    if (select_name[0] || (!jump_name[0])) {
      break;
    }
  }
  return(status);
}

/*
 * ե̺
 */

#ifdef	__STDC__
static void	rmail_redraw_folder(int current_folder)
#else	/* !__STDC__ */
static void	rmail_redraw_folder(current_folder)
     int	current_folder;
#endif	/* !__STDC__ */
{
  register int	i, j;
  char		buff[SMALL_BUFF];
  char		jname[SMALL_BUFF];

  i = top_position;
  top_position = get_top_position(top_position, current_folder,
				  rmail_select_number, mail_thread_mode, buff);
  if (i == top_position) {
    return;
  }
  print_title();
  if (wide_mode) {
    term_attrib(color_code[HEADER_COLOR]);
  } else {
    term_attrib(color_code[CATEGORY_COLOR]);
  }
  strcpy(jname, select_name);
#ifdef	JNAMES
  get_jname(RMAIL_JN_DOMAIN, jname, 40);
#endif	/* JNAMES */
  print_full_line(japanese ?
		  "ե:%-48.48s       :%s" :
		  "Folder:%-48.48s     Position:%s",
		  jname, buff);
  if (!wide_mode) {
    j = (check_new_mail() > 0);
    term_locate(0, 2);
    term_attrib(RESET_ATTRIB);
    term_attrib(color_code[HEADER_COLOR]);
    print_full_line(japanese ?
		    "      ̤    ե̾                       [%-8.8s]" :
		    "  Max     Unread  Folder name                      [%-8.8s]",
		    new_mail_string[j]);
  }
  term_attrib(RESET_ATTRIB);
  for (i = 0, j = top_position; i < term_lines - mode_lines; i++, j++) {
    if (j >= rmail_select_number) {
      break;
    }
    term_locate(0, head_lines + i);
#ifdef	COLOR
    term_attrib(color_code[NUMBER_COLOR]);
#endif	/* COLOR */
    if (rmail_s_folder[j].max_article >= 0) {
      cprintf(" %6ld  %6ld", rmail_s_folder[j].max_article,
	      rmail_s_folder[j].unread_article);
    } else {
      cprintf("         %6ld", rmail_s_folder[j].unread_article);
    }
    strcpy(buff, rmail_s_folder[j].folder_name);
#ifdef	JNAMES
    get_jname(RMAIL_JN_DOMAIN, buff, term_columns - 24);
#else	/* !JNAMES */
    buff[term_columns - 24] = '\0';
#endif	/* !JNAMES */
#ifdef	COLOR
    term_attrib(color_code[CATEGORY_COLOR]);
#endif	/* COLOR */
#ifdef	SJIS_SRC
    kanji_printf(SJIS_CODE, "   %s", buff);
#else	/* !SJIS_SRC */
    kanji_printf(EUC_CODE, "   %s", buff);
#endif	/* !SJIS_SRC */
  }
  term_attrib(RESET_ATTRIB);
  print_mode_line(japanese ?
		  "?:إ j,n,^N: k,p,^P: SPACE,i: o,q,RETURN: Q:λ" :
		  "?:help j,n,^N:next k,p,^P:previous SPACE,i:select o,q,RETURN:return Q:exit");
}

/*
 * ե
 */

#ifdef	__STDC__
static int	rmail_select_folder(void)
#else	/* !__STDC__ */
static int	rmail_select_folder()
#endif	/* !__STDC__ */
{
  /* ѿϺƵΤ static ˤʤ */

  int		current_folder;		/* Υեֹ		*/
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];
  int		loop;
  int		status;
  int		key;
  register int	i;

  top_position = -1;
  current_folder = 0;

  loop = 1;
  while (loop) {
    if (jump_name[0]) {
      key = 0;
      current_folder = -1;
      for (i = 0; i < rmail_select_number; i++) {
	if (!strnnamecmp(rmail_s_folder[i].folder_name, jump_name,
			 strlen(rmail_s_folder[i].folder_name))) {
	  current_folder = i;
	  key = ' ';
	  break;
	}
      }
      if (current_folder < 0) {
	for (i = 0; i < rmail_select_number; i++) {
	  if (!strnnamecmp(rmail_s_folder[i].folder_name, jump_name,
			   strlen(jump_name))) {
	    if (current_folder < 0) {
	      current_folder = i;
	      key = ' ';
	    } else {
	      key = 0;
	    }
	  }
	}
      }
      if (current_folder < 0) {
	current_folder = 0;
      }
      if (!key) {
	jump_name[0] = '\0';
	continue;
      }
    } else {
      rmail_redraw_folder(current_folder);
      term_locate(16, head_lines + current_folder - top_position);
      key = get_key(NEWS_MODE_MASK | GLOBAL_MODE_MASK | GROUP_MODE_MASK |
		    MOUSE_MODE_MASK);
#ifdef	MOUSE
      if (mouse_button == 0) {
	int	line;

	line = mouse_row - 1 - (wide_mode ? 1 : 3);
	if (line < 0) {
	  key = 0x02;	/* ^B */
	} else if (line >= term_lines - mode_lines) {
	  key = 0x06;	/* ^F */
	} else {
	  line += top_position;
	  if (line < rmail_select_number) {
	    current_folder = line;
	    key = 'i';
	  }
	}
      } else if (mouse_button == 1) {
	key = ' ';
      } else if (mouse_button == 2) {
	key = 'o';
      }
#endif	/* MOUSE */
    }
    switch (key) {
    case 0x0c:		/* ^L 		*/
      term_init(2);
      top_position = -1;
      break;
    case 0x10:		/* ^P եư	*/
    case 'k':
      current_folder = rmail_prev_folder(current_folder);
      break;
    case 0x0e:		/* ^N եư	*/
    case 'j':
      current_folder = rmail_next_folder(current_folder);
      break;
    case 'p':		/* p ̤ɥեư	*/
      current_folder = rmail_prev_unread_folder(current_folder);
      break;
    case 'n':		/* n ̤ɥեư	*/
      current_folder = rmail_next_unread_folder(current_folder);
      break;
    case 'o':
    case 'q':
    case '\015':	/* RETURN		*/
    case '\n':
      loop = 0;
      break;
    case 0x02:		/* ^B			*/
    case 0x15:		/* ^U ڡ		*/
      if ((current_folder -= (term_lines - mode_lines)) < 0) {
	current_folder = 0;
      }
      break;
    case 0x04:		/* ^D			*/
    case 0x06:		/* ^F			*/
    case 0x16:		/* ^V ڡ		*/
      if ((current_folder += (term_lines - mode_lines))
	  >= rmail_select_number) {
	if (rmail_select_number > 0) {
	  current_folder = rmail_select_number - 1;
	} else {
	  current_folder = 0;
	}
      }
      break;
    case '<':		/* ǽΥե	*/
      current_folder = 0;
      break;
    case '>':		/* ǸΥե	*/
      if (rmail_select_number > 0) {
	current_folder = rmail_select_number - 1;
      } else {
	current_folder = 0;
      }
      break;
    case '\t':		/* TAB ꥫƥ/եإ	*/
      strcpy(buff1, rmail_mbox);
      input_line(INPUT_SPCCUT_MASK | INPUT_FOLDER_MASK,
		 "եƥޤϥե̾ϤƲ:",
		 "Input folder category or folder name:", buff1);
      if (buff1[0]) {
	strcpy(jump_name, buff1);
	return(1);
      }
      top_position = -1;
      break;
    case '?':		/* إ		*/
      help(rmail_folder_jmessage, rmail_folder_message,
	   GLOBAL_MODE_MASK | GROUP_MODE_MASK);
      top_position = -1;
      break;
    case 'Q':		/* λ			*/
      return(1);
    case 'G':		/* ɽ⡼/	*/
      if (!select_name[0]) {
	gnus_mode = !gnus_mode;
	rmail_match_folder(select_name);
	current_folder = 0;
	top_position = -1;
      }
      break;
    case 'C':		/* ե		*/
      strcpy(buff1, rmail_mbox);
      input_line(INPUT_SPCCUT_MASK | INPUT_FOLDER_MASK,
		 "ե̾ϤƲ:",
		 "Input new folder name:", buff1);
      if (buff1[0]) {
	if (!rmail_create_folder(buff1)) {
	  if (rmail_select_number > 0) {
	    strcpy(buff1, rmail_s_folder[current_folder].folder_name);
	    rmail_search_all_folder();
	    rmail_match_folder(select_name);
	    current_folder = rmail_adjust_folder(buff1);
	  } else {
	    rmail_search_all_folder();
	    rmail_match_folder(select_name);
	    current_folder = 0;
	  }
	}
      }
      top_position = -1;
      break;
    default:
      if (rmail_select_number > 0) {
	switch (key) {
#ifdef	LARGE
	case 'I':		/* ѥեư	*/
	  if (auto_inc_folder[0]) {
	    strcpy(jump_name, auto_inc_folder);
	    return(1);
	  }
	  /* break  */
#endif	/* LARGE */
	case ' ':
	case 'i':		/* ե		*/
	  strcpy(buff1, rmail_s_folder[current_folder].folder_name);
	  strcpy(buff2, select_name);
	  strcpy(select_name, rmail_s_folder[current_folder].folder_name);
	  if (rmail_s_folder[current_folder].max_article < 0) {
	    status = rmail_menu(0);
	  } else {
	    sprintf(rmail_file, "%s%c%s", rmail_mbox, SLASH_CHAR,
		    rmail_s_folder[current_folder].folder_name);
	    status = rmail_select_article(auto_inc_mode &&
					  ((!auto_inc_folder[0]) ||
					   (!strnamecmp(auto_inc_folder,
		rmail_s_folder[current_folder].folder_name))));
	    for (i = 0; i < rmail_folder_number; i++) {
	      if (!strnamecmp(buff1, rmail_folder[i].folder_name)) {
		rmail_count(i);
		break;
	      }
	    }
	  }
	  strcpy(select_name, buff2);
	  if (status) {
	    return(1);
	  }
	  rmail_match_folder(select_name);
	  current_folder = rmail_adjust_folder(buff1);
	  top_position = -1;
	  break;
#ifndef	SMALL
	case '/':		/* 		*/
	  rmail_search_name(0, rmail_select_number, &current_folder);
	  break;
	case '\\':		/* 		*/
	  rmail_search_name(1, rmail_select_number, &current_folder);
	  break;
#endif	/* !SMALL */
	case 0x7f:		/* ե		*/
	case 0x08:
	  if (rmail_s_folder[current_folder].max_article > 0) {
	    print_mode_line(japanese ?
			    "ե(%s)϶ǤϤޤ" :
			    "Folder(%s) does not empty.",
			    rmail_s_folder[current_folder].folder_name);
	    term_bell();
	    sleep(ERROR_SLEEP);
	  } else if (rmail_s_folder[current_folder].max_article < 0) {
	    print_mode_line(japanese ?
			    "֥ե˰ưƺƲ" :
			    "Please move to sub folder and delete.");
	    term_bell();
	    sleep(ERROR_SLEEP);
	  } else {
	    if (yes_or_no(CARE_YN_MODE, "ե(%s)ޤ?",
			  "Delete folder(%s)?",
			  rmail_s_folder[current_folder].folder_name)) {
	      if (!rmail_delete_folder(rmail_s_folder[current_folder].folder_name)) {
		strcpy(buff1, rmail_s_folder[current_folder].folder_name);
		rmail_search_all_folder();
		rmail_match_folder(select_name);
		current_folder = rmail_adjust_folder(buff1);
	      }
	    }
	  }
	  top_position = -1;
	  break;
	default:
	  break;
	}
      }
      break;
    }
  }
  return(0);
}

/*
 * ̺
 */

#ifdef	__STDC__
static void	rmail_redraw_article(int current_folder, int current_article)
#else	/* !__STDC__ */
static void	rmail_redraw_article(current_folder, current_article)
     int	current_folder;
     int	current_article;
#endif	/* !__STDC__ */
{
  register int	i;
  char		buff[SMALL_BUFF];
  char		jname[SMALL_BUFF];

  i = top_position;
  top_position = get_top_position(top_position, current_article,
				  rmail_article_number, mail_thread_mode,
				  buff);
  if (i == top_position) {
    return;
  }
  print_title();
  if (wide_mode) {
    term_attrib(color_code[HEADER_COLOR]);
  } else {
    term_attrib(color_code[CATEGORY_COLOR]);
  }
  if ((int)strlen(rmail_file) > (int)strlen(rmail_mbox)) {
    strcpy(jname, &rmail_file[strlen(rmail_mbox) + 1]);
  } else {
    strcpy(jname, rmail_file);
  }
#ifdef	JNAMES
  get_jname(RMAIL_JN_DOMAIN, jname, 42);
#endif	/* JNAMES */
  print_full_line(japanese ?
		  "᡼ե:%-42.42s       :%s" :
		  "Mail file:%-42.42s        Position:%s",
		  jname, buff);
  print_articles(top_position, current_folder, rmail_article_number,
		 (int (*)())NULL, "PANIC");
}

/*
 * 
 */

#ifdef	__STDC__
static int	rmail_select_article(int auto_flag)
#else	/* !__STDC__ */
static int	rmail_select_article(auto_flag)
     int	auto_flag;
#endif	/* !__STDC__ */
{
  register int	current_folder;		/* Υեֹ		*/
  int		current_article;	/* εֹ		*/
  char		buff[BUFF_SIZE];
  char		refile_folder[BUFF_SIZE];
  int		loop;
  int		status;
  int		key;
  register int	i, j;

  current_folder = -1;
  jump_name[0] = '\0';
  for (i = 0; i < rmail_folder_number; i++) {
    if (!strnamecmp(select_name, rmail_folder[i].folder_name)) {
      current_folder = i;
      break;
    }
  }
  if ((current_folder < 0) && rmail_folder_number) {
    print_fatal("Unexpected folder selected.");
    return(0);
  }
  print_mode_line(japanese ? "Ǥ" : "Searching.");
  if (auto_flag) {	/* ưǽ		*/
    if (check_new_mail() > 0) {
      rmail_include((char*)NULL, 1);
      rmail_count(current_folder);
    }
  }
  if (rmail_get_list() < 0) {
    return(0);
  }

  /*
   * ǽ̤ɵޤǥȤʤ
   */

  current_article = 0;
  if (rmail_article_number > 0) {
    while (1) {
      if (current_article >= rmail_article_number - 1) {
	break;
      } else if (article_list[current_article].mark & READ_MARK) {
	current_article = rmail_next_unread_article(current_article);
	continue;
      } else {
	break;
      }
    }
  }
  top_position = -1;
  loop = 1;
  status = 0;
  while (loop) {
    rmail_redraw_article(current_folder, current_article);
    term_locate(article_format ? 6 : 11,
		head_lines + current_article - top_position);
    key = get_key(GLOBAL_MODE_MASK | SUBJECT_MODE_MASK | MOUSE_MODE_MASK);
#ifdef	MOUSE
    if (mouse_button == 0) {
      int	line;

      line = mouse_row - 1 - (wide_mode ? 1 : 3);
      if (line < 0) {
	key = 0x02;	/* ^B */
      } else if (line >= term_lines - mode_lines) {
	  key = 0x06;   /* ^F */
      } else {
	line += top_position;
	if (line < rmail_article_number) {
	  current_article = line;
	  key = 'i';
	}
      }
    } else if (mouse_button == 1) {
      key = ' ';
    } else if (mouse_button == 2) {
      key = 'o';
    }
#endif	/* MOUSE */
    switch (key) {
    case 0x0c:		/* ^L 		*/
      term_init(2);
      top_position = -1;
      break;
    case 0x10:		/* ^P ư	*/
    case 'k':
      current_article = rmail_prev_article(current_article);
      break;
    case 0x0e:		/* ^N ư	*/
    case 'j':
      current_article = rmail_next_article(current_article);
      break;
#ifdef	LARGE
    case '{':		/* { ޡư	*/
      current_article = rmail_prev_mark_article(current_article);
      break;
    case '}':		/* } ޡư	*/
      current_article = rmail_next_mark_article(current_article);
      break;
#endif	/* LARGE */
    case '\015':	/* RETURN		*/
    case '\n':
    case 'o':
    case 'q':
      loop = 0;
      break;
    case 0x02:		/* ^B 			*/
    case 0x15:		/* ^U ڡ		*/
      if ((current_article -= (term_lines - mode_lines)) < 0) {
	current_article = 0;
      }
      break;
    case 0x04:		/* ^D			*/
    case 0x06:		/* ^F			*/
    case 0x16:		/* ^V ڡ		*/
      if ((current_article += (term_lines - mode_lines))
	  >= rmail_article_number) {
	if (rmail_article_number > 0) {
	  current_article = rmail_article_number - 1;
	} else {
	  current_article = 0;
	}
      }
      break;
    case '<':		/* ǽε		*/
      current_article = 0;
      break;
    case '>':		/* Ǹε		*/
      if (rmail_article_number > 0) {
	current_article = rmail_article_number - 1;
      } else {
	current_article = 0;
      }
      break;
#ifndef	SMALL
    case 'L':		/* ե	*/
      buff[0] = '\0';
      input_line(INPUT_EXPAND_MASK | INPUT_COMP_MASK,
		 "ե̾ϤƲ:",
		 "Input file name:", buff);
      if (!buff[0]) {
	top_position = -1;
	break;
      }
      /* break 	*/
#endif	/* !SMALL */
    case 'I':		/* 嵭	*/
      rmail_update(0, (char*)NULL);
      if (key == 'I') {
	if (auto_inc_mode && auto_inc_folder[0]) {
	  i = check_new_mail();
	  if (i > 0) {
	    strcpy(jump_name, auto_inc_folder);
	    return(1);
	  } else if (!i) {
	    break;
	  }
	}
	rmail_include((char*)NULL, 1);
      } else {
	rmail_include(buff, 0);
      }
      rmail_count(current_folder);
      i = rmail_article_number;
      rmail_get_list();
      current_article = i;
      if (current_article >= rmail_article_number) {
	if (rmail_article_number > 0) {
	  current_article = rmail_article_number - 1;
	} else {
	  current_article = 0;
	}
      }
      top_position = -1;
      break;
    case '?':		/* إ		*/
      help(rmail_article_jmessage, rmail_article_message,
	   GLOBAL_MODE_MASK | SUBJECT_MODE_MASK);
      top_position = -1;
      break;
    case 'Q':		/* λ			*/
      loop = 0;
      status = 1;
      break;
    case 'l':		/* ɵѥå/	*/
    case 't':		/* åɥ	*/
    case 'T':		/* åɥ롼	*/
      rmail_update(0, (char*)NULL);
      if (!change_sort_rule(-1, &rmail_article_number,
			    &current_article,
			    &mail_article_mask, &mail_thread_mode,
			    rmail_get_list, key)) {
	top_position = -1;
      }
      break;
    default:
      last_key = key;
      while (last_key) {
	key = last_key;
	last_key = 0;
	switch (key) {
	case 'p':		/* ̤ɵ	*/
	case 'P':		/* 		*/
	  j = current_article;
	  if (rmail_article_number > 0) {
	    if (key == 'p') {
	      current_article = rmail_prev_unread_article(current_article);
	      status = (article_list[current_article].mark & READ_MARK) &&
		(!current_article);
	    } else {
	      current_article = rmail_prev_article(current_article);
	      status = (current_article == j);
	    }
	  } else {
	    status = 1;
	  }
	  if (status) {
	    if (rmail_folder_number) {
	      i = current_folder;
	      while (1) {
		if (--i < 0) {
		  i = current_folder;
		  break;
		}
		if (rmail_folder[i].unread_article > 0) {
		  break;
		}
	      }
	      if (i != current_folder) {
		switch (yes_or_no(JUMP_YN_MODE,
				  "Υե(%s)򻲾Ȥޤ?",
				  "Read previous folder(%s)?",
				  rmail_folder[i].folder_name)) {
		case 1:
		  rmail_update(0, (char*)NULL);
		  strcpy(jump_name, rmail_folder[i].folder_name);
		  return(1);
		case 2:
		  rmail_update(0, (char*)NULL);
		  return(0);
		default:
		  current_article = j;
		  break;
		}
		top_position = -1;
	      } else {
		current_article = j;
	      }
	    } else {
	      current_article = j;
	    }
	    key = 0;
	  }
	  status = 0;
	  break;
	case 'n':		/* ̤ɵ	*/
	case 'N':		/* ε		*/
	  j = current_article;
	  if (rmail_article_number > 0) {
	    if (key == 'n') {
	      current_article = rmail_next_unread_article(current_article);
	      status = (article_list[current_article].mark & READ_MARK) &&
		(current_article == (rmail_article_number - 1));
	    } else {
	      current_article = rmail_next_article(current_article);
	      status = (current_article == j);
	    }
	  } else {
	    status = 1;
	  }
	  if (status) {
	    i = current_folder;
	    while (1) {
	      if (++i >= rmail_folder_number) {
		i = current_folder;
		break;
	      }
	      if (rmail_folder[i].unread_article > 0) {
		break;
	      }
	    }
	    if (i != current_folder) {
	      switch (yes_or_no(JUMP_YN_MODE,
				"̤ɥե(%s)򻲾Ȥޤ?",
				"Read next unread folder(%s)?",
				rmail_folder[i].folder_name)) {
	      case 1:
		rmail_update(0, (char*)NULL);
		strcpy(jump_name, rmail_folder[i].folder_name);
		return(1);
	      case 2:
		rmail_update(0, (char*)NULL);
		return(0);
	      default:
		current_article = j;
		break;
	      }
	      top_position = -1;
	    } else {
	      current_article = j;
	    }
	    key = 0;
	  }
	  status = 0;
	  break;
	default:
	  break;
	}
	if (rmail_article_number > 0) {
	  i = 1;
	  switch (key) {
	  case 'V':		/* 		*/
	    i = 3;
	    /* break  */
	  case 'v':
	    i--;
	    key = ' ';
	    /* break  */
	  case ' ':
	  case 'p':
	  case 'n':
	  case 'P':
	  case 'N':
	  case 'i':
	  case '.':
	    if (!rmail_read(article_list[current_article].real_number, i)) {
	      switch (last_key) {
	      case 'D':
		rmail_mark(current_article, READ_MARK | DELETE_MARK);
		last_key = 'p';
		break;
	      case 'd':
		rmail_mark(current_article, READ_MARK | DELETE_MARK);
		last_key = 'n';
		break;
	      case 'Y':
		rmail_mark(current_article, READ_MARK);
		last_key = 'p';
		break;
	      case 'y':
		rmail_mark(current_article, READ_MARK);
		last_key = 'n';
		break;
	      case 'U':
		rmail_mark(current_article, READ_MARK);
		rmail_unmark(current_article, DELETE_MARK);
		last_key = 'p';
		break;
	      case 'u':
		rmail_mark(current_article, READ_MARK);
		rmail_unmark(current_article, DELETE_MARK);
		last_key = 'n';
		break;
	      case 'Z':
		rmail_unmark(current_article, READ_MARK);
		last_key = 'p';
		break;
	      case 'z':
		rmail_unmark(current_article, READ_MARK);
		last_key = 'n';
		break;
	      default:
		rmail_mark(current_article, READ_MARK);
		break;
	      }
	    }
	    if (pager_mode) {
	      switch (key) {
	      case 'p':
		current_article = rmail_prev_unread_article(current_article);
		break;
	      case 'n':
	      case ' ':
		current_article = rmail_next_unread_article(current_article);
		break;
	      case 'P':
		current_article = rmail_prev_article(current_article);
		break;
	      case 'N':
		current_article = rmail_next_article(current_article);
		break;
	      default:
		break;
	      }
	    }
	    if (last_key == ' ') {
	      last_key = 'n';
	    }
	    top_position = -1;
	    break;
	  case 'D':		/* ޡ,ư	*/
	  case 'd':		/* ޡ,ư	*/
	    rmail_mark(current_article, DELETE_MARK);
	    toggle_mark(top_position, current_article, 0);
	    if (key == 'D') {
	      current_article = rmail_prev_article(current_article);
	    } else {
	      current_article = rmail_next_article(current_article);
	    }
	    break;
	  case 'U':		/* ޡ,ư	*/
	  case 'u':		/* ޡ,ư	*/
	    rmail_unmark(current_article, DELETE_MARK);
	    toggle_mark(top_position, current_article, 0);
	    if (key == 'U') {
	      current_article = rmail_prev_article(current_article);
	    } else {
	      current_article = rmail_next_article(current_article);
	    }
	    break;
	  case 'Y':		/* ɥޡ,ư	*/
	  case 'y':		/* ɥޡ,ư	*/
	    rmail_mark(current_article, READ_MARK);
	    toggle_mark(top_position, current_article, 0);
	    if (key == 'Y') {
	      current_article = rmail_prev_article(current_article);
	    } else {
	      current_article = rmail_next_article(current_article);
	    }
	    break;
	  case 'Z':		/* ɥޡ,ư	*/
	  case 'z':		/* ɥޡ,ư	*/
	    rmail_unmark(current_article, READ_MARK);
	    toggle_mark(top_position, current_article, 0);
	    if (key == 'Z') {
	      current_article = rmail_prev_article(current_article);
	    } else {
	      current_article = rmail_next_article(current_article);
	    }
	    break;
	  case 'c':		/* ޡ		*/
	    switch (yes_or_no(MARK_YN_MODE,
			      "ޡƤǤ?",
			      "Mark all articles.Are you sure?")) {
	    case 1:	/* READ		*/
	      j = READ_MARK;
	      break;
	    case 2:	/* DELETE	*/
	      j = DELETE_MARK;
	      break;
	    default:
	      j = 0;
	      break;
	    }
	    if (j) {
	      for (i = 0; i < rmail_article_number; i++) {
		rmail_mark(i, j);
	      }
	    }
	    top_position = -1;
	    break;
	  case '^':		/* ޡե	*/
	    j = 0;
	    for (i = 0; i < rmail_article_number; i++) {
	      if (article_list[i].mark & DELETE_MARK) {
		j++;
	      }
	    }
	    if (j) {
	      strcpy(buff, rmail_mbox);
	      input_line(INPUT_SPCCUT_MASK | INPUT_FOLDER_MASK,
			 "ưե̾ϤƲ:",
			 "Input destination folder name:", buff);
	      if (buff[0]) {
		j = 0;
		for (i = 0; i < rmail_folder_number; i++) {
		  if (!strnamecmp(rmail_folder[i].folder_name, buff)) {
		    j = 1;
		    break;
		  }
		}
		if (!j)  {
		  if (yes_or_no(NORMAL_YN_MODE,
				"ե(%s)򿷵ޤ?",
				"Create folder(%s).Are you sure?",
				buff)) {
		    if (!rmail_create_folder(buff)) {
		      j = 1;
		    }
		  }
		}
		if (j) {
		  sprintf(refile_folder, "%s%c%s", rmail_mbox, SLASH_CHAR,
			  buff);
		  if (!strnamecmp(refile_folder, rmail_file)) {
		    print_mode_line(japanese ?
				    "ưȰư褬ƱեǤ" :
				    "Source and destination folders are identical.");
		    term_bell();
		    sleep(ERROR_SLEEP);
		  } else {
		    rmail_update(0, (char*)NULL);
		    rmail_update(1, refile_folder);
		    rmail_search_all_folder();
		    rmail_get_list();
		    if (current_article >= rmail_article_number) {
		      if (rmail_article_number > 0) {
			current_article = rmail_article_number - 1;
		      } else {
			current_article = 0;
		      }
		    }
		  }
		}
	      }
	      status = 0;
	      top_position = -1;
	    }
	    break;
	  case 0x7f:		/* ޡ	*/
	  case 0x08:
	    j = 0;
	    for (i = 0; i < rmail_article_number; i++) {
	      if (article_list[i].mark & DELETE_MARK) {
		j++;
	      }
	    }
	    if (j) {
	      if (yes_or_no(CARE_YN_MODE,
			    "ޡ줿ƺƤǤ?",
			    "Delete all marked articles.Are you sure?")) {
		rmail_update(1, (char*)NULL);
		rmail_count(current_folder);
		rmail_get_list();
		if (current_article >= rmail_article_number) {
		  if (rmail_article_number > 0) {
		    current_article = rmail_article_number - 1;
		  } else {
		    current_article = 0;
		  }
		}
	      }
	      status = 0;
	    }
	    top_position = -1;
	    break;
	  case 's':		/* 		*/
	    if (!multi_save(current_article, rmail_extract)) {
	      multi_add_mark(rmail_article_number, -1, current_article,
			     READ_MARK, rmail_mark);
	    }
	    top_position = -1;
	    break;
#ifndef	SMALL
	  case '/':		/* 		*/
	    search_subjects(0, rmail_article_number, &current_article,
			    (int (*)())NULL);
	    break;
	  case '\\':		/* 		*/
	    search_subjects(1, rmail_article_number, &current_article,
			    (int (*)())NULL);
	    break;
	  case '|':		/* ѥ׼¹	*/
	    if (!multi_pipe(current_article, rmail_extract)) {
	      multi_add_mark(rmail_article_number, -1, current_article,
			     READ_MARK, rmail_mark);
	    }
	    top_position = -1;
	    break;
#endif	/* !SMALL */
	  case '\t':		/* TAB 국إ	*/
	    buff[0] = '\0';
	    input_line(INPUT_SPCCUT_MASK, "ֹϤƲ:",
		       "Input article number:", buff);
	    j = atoi(buff);
	    if ((j > 0) && buff[0]) {
	      for (i = 0; i < rmail_article_number; i++) {
		if (article_list[i].real_number == j) {
		  current_article = i;
		  break;
		}
	      }
	    }
	    top_position = -1;
	    break;
#ifdef	MAILSEND
	  case 'r':		/* ᡼ֿ		*/
	    create_temp_name(buff, "RR");
	    if (!rmail_extract(article_list[current_article].real_number,
		buff)) {
	      if (!mail_reply(buff, 0, select_name, "")) {
		rmail_mark(current_article, ANSWER_MARK);
	      }
	      funlink2(buff);
	    }
	    top_position = -1;
	    break;
	  case 'R':		/* ᡼ֿ		*/
	    create_temp_name(buff, "RR");
	    if (!multi_extract(current_article, buff, rmail_extract)) {
	      if (!mail_reply(buff, REPLY_QUOTE_MASK, select_name, "")) {
		multi_add_mark(rmail_article_number, -1, current_article,
			       ANSWER_MARK, rmail_mark);
	      }
	      funlink2(buff);
	    }
	    top_position = -1;
	    break;
	  case '=':		/* ᡼ž		*/
	  case 'f':
	    create_temp_name(buff, "RT");
	    if (!multi_extract(current_article, buff, rmail_extract)) {
	      if (!mail_forward(buff, select_name)) {
		multi_add_mark(rmail_article_number, -1, current_article,
			       FORWARD_MARK, rmail_mark);
	      }
	      funlink2(buff);
	    }
	    top_position = -1;
	    break;
#ifdef	LARGE
	  case '~':		/* ᡼		*/
	    create_temp_name(buff, "RL");
	    if (!multi_extract(current_article, buff, rmail_extract)) {
	      if (!mail_relay(buff, select_name)) {
		multi_add_mark(rmail_article_number, -1, current_article,
			       FORWARD_MARK, rmail_mark);
	      }
	      funlink2(buff);
	    }
	    top_position = -1;
	    break;
#endif	/* LARGE */
#endif	/* MAILSEND */
	  case 'C':		/* ޡ		*/
	    rmail_unmark(current_article, READ_MARK | FORWARD_MARK
			 | ANSWER_MARK | DELETE_MARK);
	    if (article_list[current_article].mark & MULTI_MARK) {
	      multi_mark(top_position, current_article);
	    }
	    toggle_mark(top_position, current_article, 0);
	    current_article = rmail_next_article(current_article);
	    break;
	  case 'M':		/* ޥޡ/	*/
	    multi_mark(top_position, current_article);
	    current_article = rmail_next_article(current_article);
	    break;
#ifdef	LARGE
	  case '@':		/* 			*/
	    if (!multi_print(current_article, rmail_extract)) {
	      multi_add_mark(rmail_article_number, -1, current_article,
			     READ_MARK, rmail_mark);
	    }
	    top_position = -1;
	    break;
	  case '(':		/* 		*/
	    search_articles(0, rmail_article_number, &current_article,
			    rmail_extract);
	    break;
	  case ')':		/* 		*/
	    search_articles(1, rmail_article_number, &current_article,
			    rmail_extract);
	    break;
#endif	/* LARGE */
	  default:
	    break;
	  }
	} else if (key == ' ') {
	  last_key = 'n';
	}
	switch (last_key) {
	case 'f':
	case '=':
	case '~':
	  print_title();
	case ' ':
	case 'p':
	case 'n':
	case 'P':
	case 'N':
	case 'v':
	case 'V':
	case 'r':
	case 'R':
	case 's':
	  break;
	default:
	  last_key = 0;
	}
      }
      break;
    }
  }
  rmail_update(0, (char*)NULL);
  return(status);
}

/*
 * եֹ
 */

#ifdef	__STDC__
static int	rmail_prev_folder(int current_folder)
#else	/* !__STDC__ */
static int	rmail_prev_folder(current_folder)
     int	current_folder;
#endif	/* !__STDC__ */
{
  if (--current_folder < 0) {
    current_folder = 0;
  }
  return(current_folder);
}

/*
 * եֹ
 */

#ifdef	__STDC__
static int	rmail_next_folder(int current_folder)
#else	/* !__STDC__ */
static int	rmail_next_folder(current_folder)
     int	current_folder;
#endif	/* !__STDC__ */
{
  if (++current_folder >= rmail_select_number) {
    if (rmail_select_number > 0) {
      current_folder = rmail_select_number - 1;
    } else {
      current_folder = 0;
    }
  }
  return(current_folder);
}

/*
 * ̤ɥեֹ
 */

#ifdef	__STDC__
static int	rmail_prev_unread_folder(int current_folder)
#else	/* !__STDC__ */
static int	rmail_prev_unread_folder(current_folder)
     int	current_folder;
#endif	/* !__STDC__ */
{
  register int	i;

  i = current_folder;
  if (rmail_select_number > 0) {
    while (--i >= 0) {
      if (rmail_s_folder[i].unread_article) {
	current_folder = i;
	break;
      }
    }
  }
  return(current_folder);
}

/*
 * ̤ɥեֹ
 */

#ifdef	__STDC__
static int	rmail_next_unread_folder(int current_folder)
#else	/* !__STDC__ */
static int	rmail_next_unread_folder(current_folder)
     int	current_folder;
#endif	/* !__STDC__ */
{
  register int	i;

  i = current_folder;
  if (rmail_select_number > 0) {
    while (++i < rmail_select_number) {
      if (rmail_s_folder[i].unread_article) {
	current_folder = i;
	break;
      }
    }
  }
  return(current_folder);
}

/*
 * ֹ
 */

#ifdef	__STDC__
static int	rmail_prev_article(int current_article)
#else	/* !__STDC__ */
static int	rmail_prev_article(current_article)
     int	current_article;
#endif	/* !__STDC__ */
{
  if (--current_article < 0) {
    current_article = 0;
  }
  return(current_article);
}

/*
 * ե
 */

#ifdef	__STDC__
static int	rmail_next_article(int current_article)
#else	/* !__STDC__ */
static int	rmail_next_article(current_article)
     int	current_article;
#endif	/* !__STDC__ */
{
  if (++current_article >= rmail_article_number) {
    if (rmail_article_number > 0) {
      current_article = rmail_article_number - 1;
    } else {
      current_article = 0;
    }
  }
  return(current_article);
}

/*
 * ̤ɵֹ
 */

#ifdef	__STDC__
static int	rmail_prev_unread_article(int current_article)
#else	/* !__STDC__ */
static int	rmail_prev_unread_article(current_article)
     int	current_article;
#endif	/* !__STDC__ */
{
  term_enable_abort();
  while (current_article > 0) {
    if (!(article_list[--current_article].mark & READ_MARK)) {
      break;
    }
#ifndef	DONT_USE_ABORT
    if (check_abort()) {
      break;
    }
#endif	/* !DONT_USE_ABORT */
  }
  term_disable_abort();
  return(current_article);
}

/*
 * ̤ɵֹ
 */

#ifdef	__STDC__
static int	rmail_next_unread_article(int current_article)
#else	/* !__STDC__ */
static int	rmail_next_unread_article(current_article)
     int	current_article;
#endif	/* !__STDC__ */
{
  term_enable_abort();
  while (current_article < (rmail_article_number - 1)) {
    if (!(article_list[++current_article].mark & READ_MARK)) {
      break;
    }
#ifndef	DONT_USE_ABORT
    if (check_abort()) {
      break;
    }
#endif	/* !DONT_USE_ABORT */
  }
  term_disable_abort();
  return(current_article);
}

#ifdef	LARGE
/*
 * ޡֹ
 */

#ifdef	__STDC__
static int	rmail_prev_mark_article(int current_article)
#else	/* !__STDC__ */
static int	rmail_prev_mark_article(current_article)
     int	current_article;
#endif	/* !__STDC__ */
{
  while (current_article > 0) {
    if (article_list[--current_article].mark & DELETE_MARK) {
      break;
    }
  }
  return(current_article);
}

/*
 * ޡֹ
 */

#ifdef	__STDC__
static int	rmail_next_mark_article(int current_article)
#else	/* !__STDC__ */
static int	rmail_next_mark_article(current_article)
     int	current_article;
#endif	/* !__STDC__ */
{
  while (current_article < (rmail_article_number - 1)) {
    if (article_list[++current_article].mark & DELETE_MARK) {
      break;
    }
  }
  return(current_article);
}
#endif	/* LARGE */

/*
 * ե
 */

#ifdef	__STDC__
static void	rmail_search_all_folder(void)
#else	/* !__STDC__ */
static void	rmail_search_all_folder()
#endif	/* !__STDC__ */
{
  char		*ptr;
  register int	i;

  rmail_folder_number = rmail_alloc_number = 0;
  if (rmail_folder != (struct rmail_folder*)NULL) {
    free(rmail_folder);
    rmail_folder = (struct rmail_folder*)NULL;
  }
  rmail_search_folder("");
  if (rmail_folder_number > 0) {
    for (i = 0; i < rmail_folder_number; i++) {	/* 	*/
      ptr = rmail_folder[i].folder_name;
      while (*ptr) {
	if (*ptr == SLASH_CHAR) {
	  *ptr++ = ' ';
	} else {
	  ptr++;
	}
      }
    }
    qsort(rmail_folder, rmail_folder_number, sizeof(struct rmail_folder),
	  (int (*)())strcmp);
    for (i = 0; i < rmail_folder_number; i++) {	/* θ	*/
      ptr = rmail_folder[i].folder_name;
      while (*ptr) {
	if (*ptr == ' ') {
	  *ptr++ = SLASH_CHAR;
	} else {
	  ptr++;
	}
      }
    }
  }
}

/*
 * ե
 */

#ifdef	__STDC__
static void	rmail_search_folder(char *folder_name)
#else	/* !__STDC__ */
static void	rmail_search_folder(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
  struct rmail_folder	*rmail_alloc_ptr;
  char			pbuff1[PATH_BUFF];
  char			pbuff2[PATH_BUFF];
  char			pbuff3[PATH_BUFF];
  char			buff[BUFF_SIZE];
#ifdef	HAVE_FILES
  FILES_STRUCT		dp;
#else	/* !HAVE_FILES */
  DIR_PTR		*dp;
  DIR			*dir_ptr;
#endif	/* !HAVE_FILES */
  struct stat		stat_buff;
  char			*ptr;
  FILE			*fp;
  int			status;

#ifdef	HAVE_FILES
  if (*folder_name) {
    sprintf(pbuff1, "%s%c%s%c*.*", rmail_mbox, SLASH_CHAR, folder_name,
	    SLASH_CHAR);
  } else {
    sprintf(pbuff1, "%s%c*.*", rmail_mbox, SLASH_CHAR);
  }
  if (!dos_files(pbuff1, &dp, FILE_ATTR | DIR_ATTR)) {
    do {
#ifdef	__TURBOC__
      ptr = dp.ff_name;
#else	/* !__TURBOC__ */
      ptr = dp.name;
#endif	/* !__TURBOC__ */
#else	/* !HAVE_FILES */
  if (*folder_name) {
    sprintf(pbuff1, "%s%c%s", rmail_mbox, SLASH_CHAR, folder_name);
  } else {
    strcpy(pbuff1, rmail_mbox);
  }
  if ((dir_ptr = opendir(pbuff1)) !=(DIR*)NULL) {
    while ((dp = readdir(dir_ptr)) != (DIR_PTR*)NULL) {
      ptr = dp->d_name;
#endif	/* !HAVE_FILES */
#ifdef	HAVE_FILES
      if (*folder_name) {
	sprintf(pbuff2, "%s%c%s%c%s", rmail_mbox, SLASH_CHAR, folder_name,
		SLASH_CHAR, ptr);
      } else {
	sprintf(pbuff2, "%s%c%s", rmail_mbox, SLASH_CHAR, ptr);
      }
#else	/* !HAVE_FILES */
      sprintf(pbuff2, "%s%c%s", pbuff1, SLASH_CHAR, ptr);
#endif	/* !HAVE_FILES */
      if ((!stat(pbuff2, &stat_buff))
	  && (*(ptr + strlen(ptr) - 1) != '~')) {
	if ((stat_buff.st_mode & S_IFMT) == S_IFDIR) {
	  if (strcmp(ptr, ".") && strcmp(ptr, "..")) {
	    if (*folder_name) {
	      sprintf(pbuff3, "%s%c%s", folder_name, SLASH_CHAR, ptr);
	    } else {
	      strcpy(pbuff3, ptr);
	    }
	    rmail_search_folder(pbuff3);
	  }
	} else if ((stat_buff.st_mode & S_IFMT) == S_IFREG) {
	  fp = fopen(pbuff2, "r");
	  if (fp != (FILE*)NULL) {
	    status = 0;
	    if (fgets(buff, sizeof(buff) - 1, fp)) {
	      if ((!strcmp(buff, RMAIL_EMACS_FIELD2)) ||
		  (!strcmp(buff, RMAIL_MULE_FIELD2))) {
		status = 1;
	      }
	    }
	    if (status) {
	      if (rmail_alloc_number <= rmail_folder_number) {
		if (rmail_folder != (struct rmail_folder*)NULL) {
		  rmail_alloc_ptr = (struct rmail_folder*)
		    realloc(rmail_folder,
			    (rmail_alloc_number + RMAIL_ALLOC_COUNT)
			    * sizeof(struct rmail_folder));
		} else {
		  rmail_alloc_ptr = (struct rmail_folder*)
		    malloc((rmail_alloc_number + RMAIL_ALLOC_COUNT)
			   * sizeof(struct rmail_folder));
		}
		if (rmail_alloc_ptr == (struct rmail_folder*)NULL) {
		  print_fatal("Can't allocate memory for RMAIL folder.");
		  fclose(fp);
		  break;
		} else {
		  rmail_folder = rmail_alloc_ptr;
		  rmail_alloc_number += RMAIL_ALLOC_COUNT;
		}
	      }
	      if (*folder_name) {
		sprintf(buff, "%s%c%s", folder_name, SLASH_CHAR, ptr);
	      } else {
		strcpy(buff, ptr);
	      }
	      strcpy(rmail_folder[rmail_folder_number].folder_name, buff);
	      rmail_folder_number++;
	      rmail_count(rmail_folder_number - 1);
	    }
	    fclose(fp);
	  }
	}
      }
#ifdef	HAVE_FILES
    } while (!dos_nfiles(&dp));
#else	/* !HAVE_FILES */
    }
    closedir(dir_ptr);
#endif	/* !HAVE_FILES */
  }
  if (rmail_folder_number > 0) {
    qsort(rmail_folder, rmail_folder_number, sizeof(struct rmail_folder),
	  (int (*)())strcmp);
  }
}

/*
 * ޥå륰롼׸
 */

#ifdef	__STDC__
static void	rmail_match_folder(char *folder_name)
#else	/* !__STDC__ */
static void	rmail_match_folder(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
  int		length1, length2;
  register int	i, j, k, l;
  int		max, min;
  int		total, unread;
  int		match;
  char		*ptr;

  rmail_select_number = 0;
  if (rmail_s_folder != (struct rmail_folder*)NULL) {
    free(rmail_s_folder);
    rmail_s_folder = (struct rmail_folder*)NULL;
  }
  if (!rmail_select_number) {
    rmail_s_folder = (struct rmail_folder*)
      malloc(rmail_folder_number * sizeof(struct rmail_folder));
    if (rmail_s_folder == (struct rmail_folder*)NULL) {
      print_fatal("Can't allocate memory for UCB-mail select folder.");
      return;
    }
  }
  if (gnus_mode) {
    for (i = 0; i < rmail_folder_number; i++) {
      strcpy(rmail_s_folder[rmail_select_number].folder_name,
	     rmail_folder[i].folder_name);
      rmail_s_folder[rmail_select_number].unread_article =
	rmail_folder[i].unread_article;
      rmail_s_folder[rmail_select_number].max_article =
	rmail_folder[i].max_article;
      rmail_select_number++;
    }
  } else {

    /*
     * (vin like)⡼ɤν
     * 鲼ν mnews ܤ򤬺ʬǤ
     * νñǤͤºɤޤ
     */

    j = l = 0;
    length1 = strlen(folder_name);
    for (i = 0; i < rmail_folder_number; i++) {
      if ((!strncmp(rmail_folder[i].folder_name, folder_name, length1)) &&
	  ((!folder_name[0]) ||
	   (!rmail_folder[i].folder_name[length1]) ||
	   (rmail_folder[i].folder_name[length1] == SLASH_CHAR))) {
	match = 1;
	ptr = &rmail_folder[i].folder_name[length1];
	if (*ptr) {
	  k = 0;
	  if (*ptr == SLASH_CHAR) {
	    ptr++;
	    k++;
	  }
	  while (*ptr) {
	    if (*ptr == SLASH_CHAR) {
	      break;
	    }
	    ptr++;
	    k++;
	  }
	  k += length1;
	  for (; j < i; j++) {
	    if (!strncmp(rmail_folder[i].folder_name,
			 rmail_folder[j].folder_name,
			 k)) {
	      match = 0;
	      break;
	    }
	  }
	} else {
	  k = length1;
	}
	if (match) {
	  total = unread = 0;
	  max = min = -1;
	  length2 = k;
	  k = 0;
	  for (; l < rmail_folder_number; l++) {
	    if ((!strncmp(rmail_folder[i].folder_name,
			  rmail_folder[l].folder_name,
			  length2)) &&
		((!rmail_folder[l].folder_name[length2]) ||
		 (rmail_folder[l].folder_name[length2] == SLASH_CHAR))) {
	      total  += rmail_folder[l].max_article;
	      unread += rmail_folder[l].unread_article;
	      if (length2 == strlen(rmail_folder[l].folder_name)) {
		if (l + 1 >= rmail_folder_number) {
		  k++;
		} else if ((strncmp(rmail_folder[l].folder_name,
				    rmail_folder[l + 1].folder_name,
				    strlen(rmail_folder[l].folder_name))) ||
			   (rmail_folder[l + 1].folder_name[strlen(rmail_folder[l].folder_name)]
			    != SLASH_CHAR)) {
		  k++;
		} else if (strlen(folder_name)
			   == strlen(rmail_folder[l].folder_name)) {
		  k++;
		}
		if (k == 1) {
		  max = rmail_folder[l].max_article;
		  min = 1;
		  break;
		}
	      }
	      k = 1;
	    } else if (k) {
	      break;
	    }
	  }
#ifdef	DEBUG
	  printf("MATCH %04d:%s\n", i, rmail_folder[i].folder_name);
#endif	/* DEBUG */
	  strcpy(rmail_s_folder[rmail_select_number].folder_name,
		 rmail_folder[i].folder_name);
	  rmail_s_folder[rmail_select_number].folder_name[length2] = '\0';
	  rmail_s_folder[rmail_select_number].unread_article = unread;
	  rmail_s_folder[rmail_select_number].max_article = max;
	  rmail_select_number++;
	}
      }
    }
  }
}

/*
 * 
 */

#ifdef	__STDC__
static void	rmail_count(int folder_number)
#else	/* !__STDC__ */
static void	rmail_count(folder_number)
     int	folder_number;
#endif	/* !__STDC__ */
{
  FILE		*fp;
  char		buff[BUFF_SIZE];
  int		max_number;
  int		unread_number;

  if ((folder_number < 0) || (folder_number >= rmail_folder_number)) {
    print_fatal("Illegal RMAIL folder number.");
    return;
  }
  max_number = unread_number = 0;
  sprintf(buff, "%s%c%s", rmail_mbox, SLASH_CHAR,
	  rmail_folder[folder_number].folder_name);
  fp = fopen(buff, "r");
  if (fp != (FILE*)NULL) {
    while (1) {
      while (fgets(buff, sizeof(buff) - 1, fp)) {
	if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
	  break;
	}
      }
      if (fgets(buff, sizeof(buff) - 1, fp)) {
	max_number++;
	if (strindex(buff, RMAIL_UNSEEN_ATTRIB)) {
	  unread_number++;
	}
      } else {
	break;
      }
    }
    fclose(fp);
  }
  rmail_folder[folder_number].max_article = max_number;
  rmail_folder[folder_number].unread_article = unread_number;
}

/*
 * 
 */

#ifdef	__STDC__
static int	rmail_read(long real_number, int mode)
#else	/* !__STDC__ */
static int	rmail_read(real_number, mode)
     long	real_number;
     int	mode;
#endif	/* !__STDC__ */
{
  char	tmp_file1[PATH_BUFF];
  char	tmp_file2[PATH_BUFF];
  char	buff[SMALL_BUFF];
  int	status;

  create_temp_name(tmp_file1, "RC");
  create_temp_name(tmp_file2, "RV");
  if (rmail_extract(real_number, tmp_file1)) {
    return(1);
  }
  sprintf(buff, "%ld", real_number);
  status = exec_pager(tmp_file1, tmp_file2, mode, buff);
  funlink2(tmp_file1);
  if (status) {
    return(1);
  }
  return(0);
}

/*
 * 
 */

#ifdef	__STDC__
static int	rmail_extract(long real_number, char *tmp_file)
#else	/* !__STDC__ */
static int	rmail_extract(real_number, tmp_file)
     long	real_number;
     char	*tmp_file;
#endif	/* !__STDC__ */
{
  FILE	*fp1, *fp2;
  char	buff[BUFF_SIZE];
  int	status;

  fp1 = fopen(rmail_file, "r");
  if (fp1 == (FILE*)NULL) {
    return(1);
  }
  while (1) {
    if (!fgets(buff, sizeof(buff) - 1, fp1)) {
      fclose(fp1);
      return(1);
    }
    if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
      if (--real_number <= 0L) {
	break;
      }
    }
  }
  if (!fgets(buff, sizeof(buff) - 1, fp1)) {/*	Attribute ԤΤƤ	*/
    fclose(fp1);
    return(1);
  }
  fp2 = fopen2(tmp_file, "a");
  if (fp2 == (FILE*)NULL) {
    fclose(fp1);
    return(1);
  }
  status = 1;
  while (1) {
    if (!fgets(buff, sizeof(buff) - 1, fp1)) {
      fclose(fp1);
      return(1);
    }
    if (!strncmp(buff, RMAIL_EOOH, sizeof(RMAIL_EOOH) - 1)) {
      break;
    }
    fputs(buff, fp2);
    status = 0;
  }
  while (fgets(buff, sizeof(buff) - 1, fp1)) {
    if ((buff[0] == '\n') || (buff[0] == '\0') || status) {
      if (status) {
	fputs(buff, fp2);
      }
      while (fgets(buff, sizeof(buff) - 1, fp1)) {
	if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
	  break;
	}
	fputs(buff, fp2);
      }
      break;
    }
  }
  fclose(fp1);
  fclose(fp2);
  return(0);
}

/*
 * ޡɲ
 */

#ifdef	__STDC__
static void	rmail_mark(int current_article, int mark)
#else	/* !__STDC__ */
static void	rmail_mark(current_article, mark)
     int	current_article;
     int	mark;
#endif	/* !__STDC__ */
{
  if (!(article_list[current_article].mark & mark)) {
    article_list[current_article].mark |= mark;
    rmail_modify = 1;
  }
}

/*
 * ޡ
 */

#ifdef	__STDC__
static void	rmail_unmark(int current_article, int mark)
#else	/* !__STDC__ */
static void	rmail_unmark(current_article, mark)
     int	current_article;
     int	mark;
#endif	/* !__STDC__ */
{
  if (article_list[current_article].mark & mark) {
    article_list[current_article].mark &= ~mark;
    rmail_modify = 1;
  }
}

/*
 * ꥹȼ
 */

#ifdef	__STDC__
static int	rmail_get_list(void)
#else	/* !__STDC__ */
static int	rmail_get_list()
#endif	/* !__STDC__ */
{
  FILE			*fp;
  char			buff[BUFF_SIZE];
  static char		from_buff[BUFF_SIZE];
  static char		to_buff[BUFF_SIZE];
  static char		date_buff[MAX_FIELD_LEN];
  static char		subject_buff[BUFF_SIZE];
  static char		x_nsubj_buff[MAX_FIELD_LEN];
#ifdef	REF_SORT
  static char		message_buff[MAX_FIELD_LEN];
  static char		reference_buff[BUFF_SIZE];
  static char		in_reply_buff[BUFF_SIZE];
#endif	/* REF_SORT */
  static struct cpy_hdr	rmail_fields[] = {
    {FROM_FIELD,	from_buff,	sizeof(from_buff)},
#ifdef	LARGE
    {TO_FIELD,		to_buff,	sizeof(to_buff)},
#endif	/* LARGE */
    {DATE_FIELD,	date_buff,	sizeof(date_buff)},
    {SUBJECT_FIELD,	subject_buff,	sizeof(subject_buff)},
    {X_NSUBJ_FIELD,	x_nsubj_buff,	sizeof(x_nsubj_buff)},
#ifdef	REF_SORT
    {MESSAGE_FIELD,	message_buff,	sizeof(message_buff)},
    {REFERENCE_FIELD,	reference_buff,	sizeof(reference_buff)},
    {IN_REPLY_FIELD,	in_reply_buff,	sizeof(in_reply_buff)},
#endif	/* REF_SORT */
  };
  char			*alloc_ptr;
#ifdef	REF_SORT
  char			*ptr;
#else	/* !REF_SORT */
  short			year;
#endif	/* !REF_SORT */
  short			day, hour, minute, second;
  int			alloc_number;
  int			mark;
  register int		lines;

  rmail_article_number = rmail_modify = multi_number = 0;
  if (article_list != (ARTICLE_LIST*)NULL) {
    free(article_list);
  }
  article_list = (ARTICLE_LIST*)NULL;
  alloc_number = 0;
  fp = fopen(rmail_file, "r");
  if (fp == (FILE*)NULL) {
    return(1);
  }
  while (fgets(buff, sizeof(buff) - 1, fp)) {
    if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
      break;
    }
  }
  while (fgets(buff, sizeof(buff) - 1, fp)) {
    mark = 0;
    if (!strindex(buff, RMAIL_UNSEEN_ATTRIB)) {
      mark |= READ_MARK;
    }
    if (strindex(buff, RMAIL_FORWARD_ATTRIB)) {
      mark |= FORWARD_MARK;
    }
    if (strindex(buff, RMAIL_ANSWER_ATTRIB)) {
      mark |= ANSWER_MARK;
    }
    if (strindex(buff, RMAIL_DELETE_ATTRIB)) {
      mark |= DELETE_MARK;
    }
    second = atoi(buff);
    if (second) {
      lines = copy_fields(fp, rmail_fields,
			  sizeof(rmail_fields) / sizeof(struct cpy_hdr),
			  CF_CLR_MASK | CF_GET_MASK | CF_SPC_MASK);
    }
    while (fgets(buff, sizeof(buff) - 1, fp)) {
      if (!strncmp(buff, RMAIL_EOOH, sizeof(RMAIL_EOOH) - 1)) {
	break;
      }
    }
    if (second) {
      copy_fields(fp, rmail_fields, 0,	/* ɤ߼ΤƤʤΤ 0 ɤ	*/
		  CF_CLR_MASK | CF_GET_MASK | CF_SPC_MASK);
    } else {
      lines = copy_fields(fp, rmail_fields,
			  sizeof(rmail_fields) / sizeof(struct cpy_hdr),
			  CF_CLR_MASK | CF_GET_MASK | CF_SPC_MASK);
    }
    while (fgets(buff, sizeof(buff) - 1, fp)) {
      if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
	break;
      }
      lines++;
    }
    if (alloc_number <= rmail_article_number) {
      if (article_list != (ARTICLE_LIST*)NULL) {
	alloc_ptr = (char*)realloc(article_list,
				   sizeof(ARTICLE_LIST) *
				   (alloc_number + RMAIL_ALLOC_COUNT));
      } else {
	alloc_ptr = (char*)malloc(sizeof(ARTICLE_LIST) *
				  (alloc_number + RMAIL_ALLOC_COUNT));
      }
      if (alloc_ptr == (char*)NULL) {
	print_fatal("Can't allocate memory for RMAIL article struct.");
	break;
      }
      article_list = (ARTICLE_LIST*)alloc_ptr;
#ifdef	REF_SORT
      if (sort_rule == 1) {
	if (message_list != (MESSAGE_LIST*)NULL) {
	  alloc_ptr = (char*)realloc(message_list,
				     sizeof(MESSAGE_LIST) *
				     (alloc_number + RMAIL_ALLOC_COUNT));
	} else {
	  alloc_ptr = (char*)malloc(sizeof(MESSAGE_LIST) *
				    (alloc_number + RMAIL_ALLOC_COUNT));
	}
	if (alloc_ptr == (char*)NULL) {
	  print_fatal("Can't allocate memory for message struct.");
	  break;
	}
	message_list = (MESSAGE_LIST*)alloc_ptr;
      }
#endif	/* REF_SORT */
      alloc_number += RMAIL_ALLOC_COUNT;
    }
    article_list[rmail_article_number].real_number = rmail_article_number + 1;
    article_list[rmail_article_number].lines = lines;
    article_list[rmail_article_number].mark = mark;
    get_real_adrs(from_buff, article_list[rmail_article_number].from);
    if (my_adrs_mode) {
      if (check_my_adrs(article_list[rmail_article_number].from)) {
	article_list[rmail_article_number].from[0] = MY_ADRS_CHAR;
	get_real_adrs(to_buff, &article_list[rmail_article_number].from[1]);
      }
    }
    if (x_nsubj_mode && x_nsubj_buff[0]) {
      recover_jis(subject_buff, x_nsubj_buff);
    }
    mime_decode_func(from_buff, subject_buff, default_code);
    euc_tab_strncpy(article_list[rmail_article_number].subject, from_buff,
		    MAX_SUBJECT_LEN - 1);
#ifdef	REF_SORT
    convert_article_date(date_buff, &article_list[rmail_article_number].year,
			 &article_list[rmail_article_number].month,
			 &article_list[rmail_article_number].date,
			 &day, &hour, &minute, &second, from_buff);
    if (message_list != (MESSAGE_LIST*)NULL) {
      strncpy(message_list[rmail_article_number].msg_id, message_buff,
	      MAX_FIELD_LEN - 1);
      message_list[rmail_article_number].msg_id[MAX_FIELD_LEN - 1] = '\0';
      ptr = strrchr(reference_buff, '<');
      if (ptr != (char*)NULL) {
	strncpy(message_list[rmail_article_number].ref_id, ptr,
		MAX_FIELD_LEN - 1);
	message_list[rmail_article_number].ref_id[MAX_FIELD_LEN - 1] = '\0';
      } else {
	ptr = strrchr(in_reply_buff, '<');
	if (ptr != (char*)NULL) {
	  strncpy(message_list[rmail_article_number].ref_id, ptr,
		  MAX_FIELD_LEN - 1);
	  message_list[rmail_article_number].ref_id[MAX_FIELD_LEN - 1] = '\0';
	} else {
	  message_list[rmail_article_number].ref_id[0] = '\0';
	}
      }
      ptr = strchr(message_list[rmail_article_number].ref_id, '>');
      if (ptr != (char*)NULL) {
	*(ptr + 1) = '\0';
      }
    }
#else	/* !REF_SORT */
    convert_article_date(date_buff, &year,
			 &article_list[rmail_article_number].month,
			 &article_list[rmail_article_number].date,
			 &day, &hour, &minute, &second, from_buff);
#endif	/* !REF_SORT */
    rmail_article_number++;
  }
  fclose(fp);

  /*	Ƚ	*/

  if (sort_articles(-1, &rmail_article_number,
		    mail_thread_mode, 0,
		    (int (*)())NULL, (void (*)())NULL) < 0) {
    return(-1);
  }

  /*	ѥå	*/

#ifdef	notdef
  if (mail_article_mask) {
    pack_articles(-1, &rmail_article_number, (int (*)())NULL,
		  (void (*)())NULL);
  }
#endif	/* notdef */
  return(0);
}

/*
 * 嵭
 */

#ifdef	__STDC__
static void	rmail_include(char *spool_file, int rm_flag)
#else	/* !__STDC__ */
static void	rmail_include(spool_file, rm_flag)
     char	*spool_file;
     int	rm_flag;
#endif	/* !__STDC__ */
{
  FILE		*fp1, *fp2;
  struct stat	stat_buff;
  POP3_ERR_CODE	status;
  POP3_RD_STAT	rd_stat;
  int		mode;
  int		field;
  int		b_flag;
  int		p_flag;
  char		backup_file[PATH_BUFF];
  char		reserve_file[PATH_BUFF];
  char		buff[BUFF_SIZE];

  /*	Хååץեإ͡	*/

  create_backup_name(backup_file, rmail_file);
#if	defined(MSDOS) || defined(OS2)
  unlink(backup_file);
#endif	/* (MSDOS || OS2) */
  b_flag = 0;
  if (rename(rmail_file, backup_file)) {
    if (errno != ENOENT) {
      print_fatal("Can't backup RMAIL folder file.");
      return;
    }
  } else {
    b_flag = 1;
  }
  if (stat(backup_file, &stat_buff)) {
    stat_buff.st_mode = 0;
  }
  status = POP3_OK;
  fp1 = (FILE*)NULL;
  fp2 = fopen(rmail_file, "w");
  if (fp2 == (FILE*)NULL) {
    print_fatal("Can't save new RMAIL folder file.");
    status = POP3_ERR_PROG;
  } else {
    chmod(rmail_file, ((stat_buff.st_mode & 01777) | S_IREAD | S_IWRITE));
    print_mode_line(japanese ? "RMAIL ե򹹿Ǥ" :
		    "Updating rmail folder file.");
    fprintf(fp2, "%s", RMAIL_EMACS_FIELD1);
    fprintf(fp2, RMAIL_NOTE_FIELD1, MNEWS_VERSION);
    fprintf(fp2, RMAIL_NOTE_FIELD2);
    fprintf(fp2, RMAIL_NOTE_FIELD3);
    fprintf(fp2, "%s", RMAIL_SEPARATOR);
    if (b_flag) {
      fp1 = fopen(backup_file, "r");
      if (fp1 != (FILE*)NULL) {
	while (fgets(buff, sizeof(buff) - 1, fp1)) {
	  if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
	    break;
	  }
	}
	status = POP3_ERR_PROG;
	while (1) {
	  if (!fgets(buff, sizeof(buff) - 1, fp1)) {
	    if (status == POP3_OK) {
	      fprintf(fp2, "%s", RMAIL_SEPARATOR);
	    }
	    status = POP3_OK;
	    break;
	  }
	  if (status != POP3_OK) {
	    fprintf(fp2, "%s\n", RMAIL_SEPARATOR2);
	    status = POP3_OK;
	  }
	  if (strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
	    fputs(buff, fp2);
	  } else {
	    status = POP3_ERR_PROG;
	    fprintf(fp2, "%s", RMAIL_SEPARATOR);
	  }
	}
	fclose(fp1);
      }
    }
  }

  /*	᡼	*/

  mode = pop3_connect_mode;
  if (spool_file != (char*)NULL) {
    pop3_connect_mode = 0;
    strcpy(reserve_file, mail_spool);
    strcpy(mail_spool, spool_file);
  }
  p_flag = 0;
  if (status == POP3_OK) {
    pop3_from_mode = 0;
    status = pop3_open();
    field = 1;
    while (status == POP3_OK) {
      p_flag = 1;
      status = pop3_read(buff, sizeof(buff), &rd_stat);
      switch (rd_stat) {
      case POP3_RD_HEAD:
      case POP3_RD_SEP:
	if (field) {
	  fprintf(fp2, "%s\n0, %s,,\n", RMAIL_SEPARATOR2, RMAIL_UNSEEN_ATTRIB);
	  fprintf(fp2, "%s\n", RMAIL_EOOH);
	  field = 0;
	}
	/* break  */
      case POP3_RD_BODY:
	fputs(buff, fp2);
	break;
      case POP3_RD_FROM:
      case POP3_RD_END:
      case POP3_RD_EOF:
	if (field != 1) {
	  fprintf(fp2, "%s", RMAIL_SEPARATOR);
	  field = 1;
	}
	break;
      default:
	status = POP3_ERR_PROG;
	break;
      }
      if (rd_stat == POP3_RD_EOF) {
	break;
      }
    }
  }
  if (fp2 != (FILE*)NULL) {
    if (fflush(fp2)) {
      status = POP3_ERR_COMM;
      print_fatal("Can't save new RMAIL folder file.");
    }
    fclose(fp2);
  }
  if (status != POP3_OK) {
    if (b_flag) {
      rename(backup_file, rmail_file);
    }
    rm_flag = 0;
  }
  if (p_flag) {
    if (rm_flag && (pop3_del_mode || (!pop3_connect_mode))) {
      pop3_delete();
    }
    pop3_close();
  }
  if (spool_file != (char*)NULL) {
    pop3_connect_mode = mode;
    strcpy(mail_spool, reserve_file);
  }
}

/*
 * RMAIL ե빹(ޡ)
 * ⡼ɻ
 *	0    :ޡ
 *	0ʳ: or ư
 */

#ifdef	__STDC__
static void	rmail_update(int mode, char *refile_folder)
#else	/* !__STDC__ */
static void	rmail_update(mode, refile_folder)
     int	mode;
     char	*refile_folder;	/* ưե */
#endif	/* !__STDC__ */
{
  FILE		*fp1, *fp2, *fp3;
  struct stat	stat_buff;
  int		article_number;
  int		b_flag;
  int		status;
  char		backup_file[PATH_BUFF];
  char		buff[BUFF_SIZE];
  char		*ptr1, *ptr2;
  long		position;
  register int	i, j;
  int		ignore;

  /*	ɬå	*/

  if (!(mode || rmail_modify)) {
    return;
  }

  /*	Хååץեإ͡	*/

  create_backup_name(backup_file, rmail_file);
#if	defined(MSDOS) || defined(OS2)
  unlink(backup_file);
#endif	/* (MSDOS || OS2) */
  b_flag = 0;
  if (rename(rmail_file, backup_file)) {
    if (errno != ENOENT) {
      print_fatal("Can't backup RMAIL folder file.");
      return;
    }
  } else {
    b_flag = 1;
  }
  if (stat(backup_file, &stat_buff)) {
    stat_buff.st_mode = 0;
  }
  status = 0;
  fp1 = fopen(backup_file, "r");
  if (fp1 == (FILE*)NULL) {
    print_fatal("Can't read backup RMAIL folder file.");
    status = 1;
  }
  fp2 = fopen(rmail_file, "w");
  if (fp2 == (FILE*)NULL) {
    print_fatal("Can't save new RMAIL folder file.");
    status = 1;
  } else {
    chmod(rmail_file, ((stat_buff.st_mode & 01777) | S_IREAD | S_IWRITE));
  }
  fp3 = (FILE*)NULL;
  if (refile_folder != (char*)NULL) {
    fp3 = fopen(refile_folder, "a");
    if (fp3 == (FILE*)NULL) {
      print_fatal("Can't append RMAIL folder file.");
      status = 1;
    } else {
      print_mode_line(japanese ? "եǤ" : "Refiling.");
    }
  } else {
    if (mode) {
      print_mode_line(japanese ? "Ǥ" : "Removing.");
    } else {
      print_mode_line(japanese ? "Ǥ" : "Updating.");
    }
  }
  article_number = 0;
  while ((!status) && (!feof(fp1))) {
    if (!fgets(buff, sizeof(buff) - 1, fp1)) {
      print_fatal("Unexpected RMAIL folder file format.");
      status = 1;
      break;
    }
    if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
      break;
    }
    fputs(buff, fp2);
  }
  while ((!status) && (!feof(fp1))) {
    for (i = 0; i < rmail_article_number; i++) {
      if (article_list[i].real_number == (article_number + 1)) {
	break;
      }
    }
    if (i < rmail_article_number) {
      if (mode && (article_list[i].mark & DELETE_MARK)) {
	if (fp3 != (FILE*)NULL) {
	  fprintf(fp3, "%s\n", RMAIL_SEPARATOR2);
	}
	j = 1;
	while (fgets(buff, sizeof(buff) - 1, fp1)) {
	  if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
	    if (fp3 != (FILE*)NULL) {
	      fprintf(fp3, "%s", RMAIL_SEPARATOR);
	    }
	    break;
	  }
	  if (fp3 != (FILE*)NULL) {
	    if (j) {
	      j = 0;
	      ptr1 = strindex(buff, RMAIL_DELETE_STRING);
	      if (ptr1 != (char*)NULL) {
		ptr2 = ptr1 + sizeof(RMAIL_DELETE_STRING) - 1;
		while (*ptr2) {
		  *ptr1++ = *ptr2++;
		};
		*ptr1 = '\0';
	      }
	    }
	    fputs(buff, fp3);
	  }
	}
	article_number++;
	continue;
      }
    }
    fprintf(fp2, "%s%s\n", RMAIL_SEPARATOR, RMAIL_SEPARATOR2);
    if (i < rmail_article_number) {
      if (fgets(buff, sizeof(buff) - 1, fp1)) {
	if (buff[0] == '0') {
	  if (article_list[i].mark & READ_MARK) {
	    if (fgets(buff, sizeof(buff) - 1, fp1)) {
	      fprintf(fp2, "1,");
	      if (article_list[i].mark & FORWARD_MARK) {
		fprintf(fp2, " %s,", RMAIL_FORWARD_ATTRIB);
	      }
	      if (article_list[i].mark & ANSWER_MARK) {
		fprintf(fp2, " %s,", RMAIL_ANSWER_ATTRIB);
	      }
	      if (article_list[i].mark & DELETE_MARK) {
		fprintf(fp2, " %s,", RMAIL_DELETE_ATTRIB);
	      }
	      fprintf(fp2, ",\n");
	      if (strncmp(buff, RMAIL_EOOH, sizeof(RMAIL_EOOH) - 1)) {
		print_fatal("Unexpected RMAIL folder file format.");
	      }
	      position = ftell(fp1);
	      while (fgets(buff, sizeof(buff) - 1, fp1)) {
		fputs(buff, fp2);
		if ((buff[0] == '\n') || (buff[0] == '\0')) {
		  break;
		}
	      }
	      fprintf(fp2, "%s\n", RMAIL_EOOH);
	      fseek(fp1, (long)position, 0);
	      ignore = 0;
	      while (fgets(buff, sizeof(buff) - 1, fp1)) {
		if ((buff[0] != ' ') && (buff[0] != '\t')) {
		  ignore = 0;
		  for (j = 0; j < (sizeof(rmail_ignore_field)
				   / sizeof(char*)); j++) {
		    if (!strncasecmp(buff, rmail_ignore_field[j],
				     strlen(rmail_ignore_field[j]))) {
		      ignore = 1;
		      break;
		    }
		  }
		}
		if (!ignore) {
		  fputs(buff, fp2);
		}
		if ((buff[0] == '\n') || (buff[0] == '\0')) {
		  break;
		}
	      }
	    }
	  } else {
	    fprintf(fp2, "0, %s,", RMAIL_UNSEEN_ATTRIB);
	    if (article_list[i].mark & FORWARD_MARK) {
	      fprintf(fp2, " %s,", RMAIL_FORWARD_ATTRIB);
	    }
	    if (article_list[i].mark & ANSWER_MARK) {
	      fprintf(fp2, " %s,", RMAIL_ANSWER_ATTRIB);
	    }
	    if (article_list[i].mark & DELETE_MARK) {
	      fprintf(fp2, " %s,", RMAIL_DELETE_ATTRIB);
	    }
	    fprintf(fp2, ",\n");
	  }
	} else {
	  if (article_list[i].mark & READ_MARK) {
	    fprintf(fp2, "1,");
	    if (article_list[i].mark & FORWARD_MARK) {
	      fprintf(fp2, " %s,", RMAIL_FORWARD_ATTRIB);
	    }
	    if (article_list[i].mark & ANSWER_MARK) {
	      fprintf(fp2, " %s,", RMAIL_ANSWER_ATTRIB);
	    }
	    if (article_list[i].mark & DELETE_MARK) {
	      fprintf(fp2, " %s,", RMAIL_DELETE_ATTRIB);
	    }
	    fprintf(fp2, ",\n");
	  } else {
	    fprintf(fp2, "0, %s,", RMAIL_UNSEEN_ATTRIB);
	    if (article_list[i].mark & FORWARD_MARK) {
	      fprintf(fp2, " %s,", RMAIL_FORWARD_ATTRIB);
	    }
	    if (article_list[i].mark & ANSWER_MARK) {
	      fprintf(fp2, " %s,", RMAIL_ANSWER_ATTRIB);
	    }
	    if (article_list[i].mark & DELETE_MARK) {
	      fprintf(fp2, " %s,", RMAIL_DELETE_ATTRIB);
	    }
	    fprintf(fp2, ",\n");
	    fprintf(fp2, "%s\n", RMAIL_EOOH);
	    while (fgets(buff, sizeof(buff) - 1, fp1)) {
	      if (!strncmp(buff, RMAIL_EOOH, sizeof(RMAIL_EOOH) - 1)) {
		while (fgets(buff, sizeof(buff) - 1, fp1)) {
		  if ((buff[0] == '\n') || (buff[0] == '\0')) {
		    break;
		  }
		}
		break;
	      }
	      fputs(buff, fp2);
	    }
	  }
	}
      }
    }
    while (fgets(buff, sizeof(buff) - 1, fp1)) {
      if (!strncmp(buff, RMAIL_SEPARATOR, sizeof(RMAIL_SEPARATOR) - 1)) {
	break;
      }
      fputs(buff, fp2);
    }
    article_number++;
  }
  if (fp1 != (FILE*)NULL) {
    fclose(fp1);
  }
  if (fp2 != (FILE*)NULL) {
    fprintf(fp2, "%s", RMAIL_SEPARATOR);
    if (fflush(fp2)) {
      status = 1;
    }
    fclose(fp2);
  }
  if (fp3 != (FILE*)NULL) {
    if (fflush(fp3)) {
      status = 1;
    }
    fclose(fp3);
  }
  if (status) {
    print_fatal("Can't update RMAIL folder file.");
    if (b_flag) {
      rename(backup_file, rmail_file);
    }
  }
}

/*
 * ե
 */

#ifdef	__STDC__
static int	rmail_create_folder(char *folder_name)
#else	/* !__STDC__ */
static int	rmail_create_folder(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
  struct stat	stat_buff;
  FILE		*fp;
  char		buff[PATH_BUFF];
  char		*ptr;
  int		status;

  strcpy(buff, rmail_mbox);
  ptr = buff;
  while (*ptr) {
    ptr++;
  }
  *ptr++ = SLASH_CHAR;
  strcpy(ptr, folder_name);
  ptr = strrchr(ptr, SLASH_CHAR);
  if (ptr != (char*)NULL) {
    *ptr = '\0';
    status = make_dir(buff, (S_IREAD | S_IWRITE | S_IEXEC));
    *ptr = SLASH_CHAR;
  } else {
    status = 0;
  }
  if (!status) {
    if (stat(buff, &stat_buff)) {
      fp = fopen(buff, "w");
      if (fp != (FILE*)NULL) {
	chmod(buff, S_IREAD | S_IWRITE);
	fprintf(fp, "%s", RMAIL_EMACS_FIELD1);
	fprintf(fp, RMAIL_NOTE_FIELD1, MNEWS_VERSION);
	fprintf(fp, RMAIL_NOTE_FIELD2);
	fprintf(fp, RMAIL_NOTE_FIELD3);
	fprintf(fp, "%s", RMAIL_SEPARATOR);
	fclose(fp);
	return(0);
      }
    }
  }
  term_bell();
  print_mode_line(japanese ? "եǤޤǤ" :
		  "Can't create folder.");
  sleep(ERROR_SLEEP);
  return(1);
}

/*
 * ե
 */

#ifdef	__STDC__
static int	rmail_delete_folder(char *folder_name)
#else	/* !__STDC__ */
static int	rmail_delete_folder(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
  char		buff[PATH_BUFF];

  sprintf(buff, "%s%c%s", rmail_mbox, SLASH_CHAR, folder_name);
  if (!unlink(buff)) {
    return(0);
  }
  term_bell();
  print_mode_line(japanese ? "եǤޤǤ" :
		  "Can't delete folder.");
  sleep(ERROR_SLEEP);
  return(1);
}

/*
 * ե
 */

#ifdef	__STDC__
static int	rmail_adjust_folder(char *folder_name)
#else	/* !__STDC__ */
static int	rmail_adjust_folder(folder_name)
     char	*folder_name;
#endif	/* !__STDC__ */
{
  int	current_folder;
  int	i;

  current_folder = 0;
  for (i = 0; i < rmail_select_number; i++) {
    if (strnamecmp(rmail_s_folder[i].folder_name, folder_name) > 0) {
      break;
    }
    current_folder = i;
  }
  return(current_folder);
}

#ifndef	SMALL
/*
 * ե̾(ʣ)
 */

#ifdef	__STDC__
static int	rmail_search_name(int mode, int max_folder, int *folder_ptr)
#else	/* !__STDC__ */
static int	rmail_search_name(mode, max_folder, folder_ptr)
     int	mode;
     int	max_folder;
     int	*folder_ptr;
#endif	/* !__STDC__ */
{
  register int	current_folder;
  char		*str;

  str = input_search_string(mode);
  if (str != (char*)NULL) {
    if (mode) {
      for (current_folder = *folder_ptr - 1; current_folder >= 0;
	   current_folder--) {
	if (strindex(rmail_s_folder[current_folder].folder_name, str)) {
	  print_mode_line(japanese ? "Ĥޤ" : "Search succeed.");
	  *folder_ptr = current_folder;
	  return(0);
	}
      }
    } else {
      for (current_folder = *folder_ptr + 1; current_folder < max_folder;
	   current_folder++) {
	if (strindex(rmail_s_folder[current_folder].folder_name, str)) {
	  print_mode_line(japanese ? "Ĥޤ" : "Search succeed.");
	  *folder_ptr = current_folder;
	  return(0);
	}
      }
    }
    print_mode_line(japanese ? "ĤޤǤ" : "Search failed.");
    return(1);
  }
  return(0);
}
#endif	/* !SMALL */
#endif	/* RMAIL */
